/* ###############################################
   # Copyright 2002, 2003 Ren Serral,           #
   #                      Roberto Borgione       #
   # conv.c - Format conversion module           #
   #       v2.0 (04-2002)                        #
   #       v2.01(02-2003)                        #
   ###############################################

   This file is part of NetMeter.

   NetMeter is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2 of the License, or
   (at your option) any later version.

   NetMeter is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with NetMeter; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
						    
*/

#include <string.h>
#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include <fcntl.h>
#include <string.h>


#define MAX_PACKETS 20000  // max packets for flows


// var ----------------------------

  int  file_index[MAX_PACKETS];
  int  countp,countf,count,countx,county,countk,temp,count_seek;
  int  n1;
  int  size;
  FILE *f=NULL,*f1=NULL,*f2=NULL;
  int  max_countf;
  int  offset;
  char line[300],line1[300],line2[300],line3[300];
  char rx_time[20],tx_time[20];
  int  fd;
  unsigned int num;


// ------------------------------------------------------------------------
//                       M     A       I       N
// ------------------------------------------------------------------------
int main (int argc, char *argv[])
{
   printf("\n HpBroadband - Mgen file converter");
   printf("\n\n list of parameters:");
   printf("\n - Broadband input  file (output flow) = out.txt");
   printf("\n - Broadband input  file (input  flow) =  in.txt");
   printf("\n - output name = %s",argv[1]);
   printf("\n\n making Mgen output files:");
   printf("\n - TX=(Atm-broadband)input - RX=(Atm-broadband) output (DLY) = %s",argv[1]);
   if (argc!=2)
   {
      printf("\n HpBroadband - Mgen file converter\n\nUsage: Broadconv output  \n");
      exit (-1);
   }
   f1=fopen("out.txt","r");
   if (f1==NULL)
   {
      printf("\n\n ERROR...!!! Input file1 not found.\n");
      exit (-1);
   }
   f2=fopen("in.txt","r");
   if (f2==NULL)
   {
      printf("\n\n ERROR...!!! Input file2 not found.\n");
      exit (-1);
   }
   // -------------------------------------------------------------------


   f=fopen(argv[1],"w");
   if (f==NULL)
   {
      printf("\n\n ERROR...!!! Can't create output file\n");
      exit (-1);
   }



max_countf=1;
countf=1;
do {

   fseek(f2, 0L, 0);
   for (count=0; count<MAX_PACKETS; count++)
     file_index[count]=-1;

   count_seek=0;
   if ((fd = open("temp.tmp", O_WRONLY | O_CREAT | O_TRUNC)) == -1)
   {
      printf("Error creating temp file.\n");
      exit(-1);
   }


   // --------------------------------------------------------
   //      Making temporary output file for first flow
   // --------------------------------------------------------
   while(!feof(f2))
   {
      fgets(line,256,f2);
      fgets(line1,256,f2);
      fgets(line2,256,f2);
      fgets(line3,256,f2);

      if (feof(f2))  break;

      num=atoi(line2);
      if (num>15) 
      {
           printf("\n\nFlow number %d illegal.!\n",num);
           printf("on line: %s \n",line2);
           exit(-1);
      }
      if (num>max_countf) max_countf=num;
      if (num==countf)
      {
            //reading sequence number < 0x0FFFF
            num=atoi(line1);
            if (num>MAX_PACKETS)
            {
              printf("\n warnings flow %d too many packets: %u \n",countf,num);
              //printf("on line: %s :.\n",line1);
            }
            else
            {
              if (write(fd, line, 15)!= 15)
              {
                 printf("Error writing to the file.\n");
                 exit(1);
              }
              file_index[num]=count_seek;
              count_seek++;
            }
      }
   }
   close(fd);
   printf("\n\n - number of detected flows: %d\n\n",max_countf);







   // --------------------------------------------------------
   //         reading temp file  with output flow
   // --------------------------------------------------------
   if ((fd = open("temp.tmp", O_RDONLY)) == -1)
   {
      printf("Error reading temp file.\n");
      exit(-1);
   }


   // reading second file
   fseek(f1, 0L, 0);
   while(!feof(f1))
   {
        fgets(line, 256,f1);
        fgets(line1,256,f1);
        fgets(line2,256,f1);
        fgets(line3,256,f1);
        if (feof(f1))  break;

        //reading flow number <0x0FF
        num=atoi(line2);

        if (num>15) {
            printf("\n\nf1 - Flow number %d illegal.!\n",num);
            printf("f1 - on line: %s \n",line2);
            exit(-1);
         }
         if (num==countf)
         {
            //reading sequence number < 0x0FFFF
            num=atoi(line1);
            if (num>MAX_PACKETS)
            {
              printf("\nf1 -  warnings flow %d too many packets: %u \n",countf,num);
              //printf("on line: %s :.\n",line1);
            }
            else
            {
              lseek(fd, (file_index[num]*15), 0);
              if ((read(fd,tx_time, 15)) == -1) {
                 printf("f1 - Error reading the file.\n");
                 exit(1);
              }
              strncpy(rx_time,line, 15);
              tx_time[15]='\0';
              rx_time[15]='\0';
              size=atoi(line3);
              fprintf(f,"Flow>%.4d Seq>%.6d Src> 0.0.0.0/0503 Dest>   1.1.1.1/%d TxTime>%s RxTime>%s Size>%.4d\n",countf,num,countf,tx_time,rx_time,size);
            }
         }
   }
   // -------------------------------------------------------------------

   countf++;
} while (countf<=max_countf);


   fclose(f);       // Out
   fclose(f1);      // In1
   fclose(f2);      // In2
}


