###############################################
# Copyright 2002, 2003 Ren Serral,           #
#                                             #
# delaym6a.tcl - Multicast Delay IPv6 Manager #
#       v1.0 (10-2002)                        #
###############################################

#   This file is part of NetMeter.
#
#   NetMeter is free software; you can redistribute it and/or modify
#   it under the terms of the GNU General Public License as published by
#   the Free Software Foundation; either version 2 of the License, or
#   (at your option) any later version.
#
#   NetMeter is distributed in the hope that it will be useful,
#   but WITHOUT ANY WARRANTY; without even the implied warranty of
#   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#   GNU General Public License for more details.
#
#   You should have received a copy of the GNU General Public License
#   along with NetMeter; if not, write to the Free Software
#   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

###################################################################
#------------------------------------------------------------------
#             Delay:Dm6      (Multicast Ipv6 case)
#------------------------------------------------------------------
###################################################################
# Atenci, ara aix s una cpia del fitxer delayu6a !!!!! has de fer la versi correcta
proc Delay:Dm6 {}\
{
   #variable ipversion indipendent
   global sender receiver host
   global dlyM
   global mul6
   global head6M
   global decodepath
   global mcalcpath
   global userLB6M

   #variable ipversion dipendent
   global flow6M		;#flow array to hold flows data
   global flow6MLB	;#flows listbox
   global mod6M

   global logDelayLB6M	;#status console
   global customEndD6M
   global runB6M		;#run test button
   global xflowview6

   global KeySocket
   global socksize
   global KeySource
   global ipv6SourceAddress
   global paramM6 pM6 countPM6
   global mul6


   set xflowview6 1977

   set customEndD 0
   #script listbox
   frame $mul6.up
   pack $mul6.up -pady 3 -fill x

   #up-left frame (options)
   frame $mul6.up.left -bd 2 -relief groove
   pack $mul6.up.left -pady 3 -fill x -side left -anchor n

   #up-right frame (script listboxes)
   frame $mul6.up.right -bd 2 -relief groove
   pack $mul6.up.right -pady 3 -padx 3 -fill both -side right \
   -expand true -anchor n

   ##############################################################
   ## define widgets for mgen and drec options
   ##############################################################
   label $mul6.up.left.titleL -text "IPv6 - Mgen6 and Drec6 Options" -relief raised
   pack $mul6.up.left.titleL  -anchor c  -fill x -padx 3 -pady 3

   frame $mul6.up.left.title
   pack $mul6.up.left.title -pady 2 -fill x
   label $mul6.up.left.title.l -text "Title measure"
   pack $mul6.up.left.title.l -side left -padx 3
   entry $mul6.up.left.title.e -textvariable dlyM(title,ipv6) -width 28
   pack $mul6.up.left.title.e -side right -padx 3

   #### Start time
   frame $mul6.up.left.start
   pack $mul6.up.left.start -pady 3 -fill x
   checkbutton $mul6.up.left.start.cB -variable dlyM(startBool6) \
   -text "Start (hh:mm:ss)" -command {
      if $dlyM(startBool6) {
          #enable entry
          $mul6.up.left.start.e config -state normal -fg black
      } else {
          #disable entry
          $mul6.up.left.start.e config -state disabled -fg gray
      }
   }
   if $dlyM(startBool6) {
      entry $mul6.up.left.start.e -textvariable dlyM(start6) -state normal
   } else {
      entry $mul6.up.left.start.e -textvariable dlyM(start6) -state disabled -fg gray
   }
   pack $mul6.up.left.start.cB -padx 3 -side left
   pack $mul6.up.left.start.e  -padx 3 -side right

   ###################################################### 
   #### Source port ##################################### 
   ###################################################### 

   frame $mul6.up.left.srcPort
   pack  $mul6.up.left.srcPort -pady 3 -fill x
   checkbutton $mul6.up.left.srcPort.cB -variable dlyM(srcPortBool6) \
   -text "Source Port" -command {
      if $dlyM(srcPortBool6) {
         #enable entry
         $mul6.up.left.srcPort.e config -state normal -fg black
      } else {
         #disable entry
         $mul6.up.left.srcPort.e config -state disabled -fg gray
      }
   }
   if $dlyM(srcPortBool6) {
      #enable entry
      entry $mul6.up.left.srcPort.e -textvariable dlyM(srcPort6) \
      -state normal
   } else {
      #disable entry
      entry $mul6.up.left.srcPort.e -textvariable dlyM(srcPort6) \
      -state disabled -fg gray
   }
   pack $mul6.up.left.srcPort.cB -padx 3 -side left
   pack $mul6.up.left.srcPort.e -padx 3 -side right

   ###################################################### 
   #### Source Address ##################################
   ###################################################### 
   frame $mul6.up.left.addrPort
#   pack  $mul6.up.left.addrPort -pady 3 -fill x
   checkbutton $mul6.up.left.addrPort.cB -variable KeySource \
   -text "Source Address" -command {
      if $KeySource {
         #enable entry
         $mul6.up.left.addrPort.e config -state normal -fg black
      } else {
         #disable entry
         $mul6.up.left.addrPort.e config -state disabled -fg gray
      }
   }
   if $KeySource {
      #enable entry
      entry $mul6.up.left.addrPort.e -textvariable ipv6SourceAddress \
      -state normal
   } else {
      #disable entry
      entry $mul6.up.left.addrPort.e -textvariable ipv6SourceAddress \
      -state disabled -fg gray
   }
#   pack $mul6.up.left.addrPort.cB -padx 3 -side left
#   pack $mul6.up.left.addrPort.e  -padx 3 -side right

   ###################################################### 
   #### Socket size ##################################### 
   ###################################################### 
   frame       $mul6.up.left.socket
#   pack        $mul6.up.left.socket       -pady 3 -fill x
   checkbutton $mul6.up.left.socket.check -variable KeySocket \
   -text "Socket buffer size" -command {
      if $KeySocket {
          #enable entry
          $mul6.up.left.socket.entry config -state normal   -fg black
      } else {
          #disable entry
          $mul6.up.left.socket.entry config -state disabled -fg gray
      }
   }
   if $KeySocket {
      entry $mul6.up.left.socket.entry -textvariable socksize -state normal
   } else {
      entry $mul6.up.left.socket.entry -textvariable socksize -state disabled -fg gray
   }
#   pack  $mul6.up.left.socket.entry -padx 3 -side right
#   pack  $mul6.up.left.socket.check -padx 3 -side left

   ######################################################### 
   # flows list
   ######################################################### 
   frame  $mul6.up.left.flowl -bd 2 -relief groove
   pack $mul6.up.left.flowl -fill x -pady 5

   #a label
   label $mul6.up.left.flowl.label -text "Flows List - (type IPv6)" -relief sunken 
   pack $mul6.up.left.flowl.label -side top -fill x -pady 3

   #listbox for displaying currently defined
   #flows and their properties
   set flow6MLB [listbox $mul6.up.left.flowl.flowlist -height 9]
   set fsy [scrollbar $mul6.up.left.flowl.flowsy -orient vertical \
   -command "$flow6MLB yview"]
   $flow6MLB config -yscrollcommand "$fsy set"

   bind $mul6.up.left.flowl.flowlist <Double-1> {
     ViewMflow6
   }

   pack $fsy -side right -fill y -pady 3
   pack $flow6MLB -side left -fill both  -expand true -pady 3

   #############################################################
   ## frame for flow operations: add, delete, and MODify
   #############################################################
   frame $mul6.up.left.flow
   pack $mul6.up.left.flow 
   button $mul6.up.left.flow.editB -text "Edit\nFlow\n" \
   -command { EditMflow6 0 } -bd 2 -relief groove -width 2
   button $mul6.up.left.flow.addB -text "Add\nnew\nFlow" \
   -command { AddMflow6 0 } -bd 2 -relief groove -width 4
   button $mul6.up.left.flow.delB -text "Delete\nlast\nFlow" \
   -command DeleteMflow6 -bd 2 -relief groove   -width 4
   button $mul6.up.left.flow.modB -text "Add\nchanges\nto Flow" \
   -command ModifyMflow6 -bd 2 -relief groove   -width 6
   button $mul6.up.left.flow.addHB -text "Add\nextension\nheader" \
   -command AddMHeader6 -bd 2 -relief groove    -width 6

   pack $mul6.up.left.flow.editB $mul6.up.left.flow.addB $mul6.up.left.flow.modB \
   $mul6.up.left.flow.addHB $mul6.up.left.flow.delB -padx 3 -anchor c -side left
   #$mul6.up.left.flow.viewB     \
   $mul6.up.left.flow.delB -padx 1 -anchor c -side left

   #############################################################
   ## Listbox View selected Flow
   #############################################################
   frame $mul6.up.right.custom -bd 2 -relief groove
   pack  $mul6.up.right.custom -fill x


   frame  $mul6.up.right.custom.b
   pack   $mul6.up.right.custom.b  -side bottom -expand true
   label  $mul6.up.right.custom.b.l -text "Parameters"
   pack   $mul6.up.right.custom.b.l -side left
   button $mul6.up.right.custom.b.b1 -text "Add" \
   -command AddParameterM6 -bd 2 -relief groove -width 2
   button $mul6.up.right.custom.b.b2 -text "Edit" \
   -command EditParameterM6 -bd 2 -relief groove -width 2
   button $mul6.up.right.custom.b.b3 -text "Del" \
   -command RemoveParameterM6 -bd 2 -relief groove -width 2

   set x "(parameters)"
   set paramM6($x) "0"
   eval tk_optionMenu $mul6.up.right.custom.b.bx pM6 [lsort [array names paramM6 ]]
   $mul6.up.right.custom.b.bx configure -width 20

   pack $mul6.up.right.custom.b.b1 $mul6.up.right.custom.b.b3\
   $mul6.up.right.custom.b.b2 $mul6.up.right.custom.b.bx -side left
   label $mul6.up.right.custom.l -text "flow parameters (to select double click on flow list)"
   pack  $mul6.up.right.custom.l -padx 3 -anchor c
   frame $mul6.up.right.custom.lb
   pack $mul6.up.right.custom.lb -pady 3 -fill both -expand true
   set userLB6M [listbox $mul6.up.right.custom.lb.customLB -height 8]
   set usy [scrollbar $mul6.up.right.custom.lb.sY -orient vertical\
   -command "$userLB6M yview"]
    set usx [scrollbar $mul6.up.right.custom.lb.sX -orient horizontal\
   -command "$userLB6M xview"]
   $userLB6M config -yscrollcommand "$usy set" -xscrollcommand "$usx set"

   pack $usy -side right -fill y -pady 2
   pack $usx -side bottom -fill x -padx 2
   pack $userLB6M -fill both -padx 2 -pady 2 -side left -expand true

   #############################################################
   ## frame for path settings and features :)
   #############################################################
   frame $mul6.up.right.path
   pack $mul6.up.right.path -fill x -pady 3 \
   -expand true -padx 3

   #and settings
   frame $mul6.up.right.path.mgenPath
   pack $mul6.up.right.path.mgenPath -pady 2 -fill x
   label $mul6.up.right.path.mgenPath.l -text "(SRC)Set Mgen Path"
   pack $mul6.up.right.path.mgenPath.l -side left -padx 3
   entry $mul6.up.right.path.mgenPath.e -textvariable dlyM(mgenPath,ipv6) \
   -width 24
   pack $mul6.up.right.path.mgenPath.e -side right -padx 3
 
   frame $mul6.up.right.path.drecPath
   pack $mul6.up.right.path.drecPath -pady 2 -fill x
   label $mul6.up.right.path.drecPath.l -text "(DST)Set Drec Path"
   pack $mul6.up.right.path.drecPath.l -side left -padx 3
   entry $mul6.up.right.path.drecPath.e -textvariable dlyM(drecPath,ipv6) \
   -width 24
   pack $mul6.up.right.path.drecPath.e -side right -padx 3

   frame $mul6.up.right.path.decodepath
   pack $mul6.up.right.path.decodepath -pady 2 -fill x
   label $mul6.up.right.path.decodepath.l -text "(DST)Set Decode Path"
   pack $mul6.up.right.path.decodepath.l -side left -padx 3 
   entry $mul6.up.right.path.decodepath.e -textvariable decodepath  \
   -width 24
   pack $mul6.up.right.path.decodepath.e -side right -padx 3 

   frame $mul6.up.right.path.mcalcpath
   pack $mul6.up.right.path.mcalcpath -pady 2 -fill x 
   label $mul6.up.right.path.mcalcpath.l -text "(LOC)Set Mcalc Path"
   pack $mul6.up.right.path.mcalcpath.l -side left -padx 3 
   entry $mul6.up.right.path.mcalcpath.e -textvariable mcalcpath      \
   -width 24
   pack $mul6.up.right.path.mcalcpath.e -side right -padx 3 

   frame $mul6.up.right.path.delaySave
   pack $mul6.up.right.path.delaySave -pady 2 -fill x
   label $mul6.up.right.path.delaySave.l -text "(LOC)Save Results File"
   pack $mul6.up.right.path.delaySave.l -side left -padx 3
   entry $mul6.up.right.path.delaySave.e -textvariable dlyM(resultsFile,ipv6) \
   -width 24
   pack $mul6.up.right.path.delaySave.e -side right -padx 3

   #down frame
   frame $mul6.down
   pack $mul6.down -fill x

   #frame for action buttons:
   frame $mul6.down.action -bd 2 -relief groove
   pack $mul6.down.action -padx 3 -padx 3 -side left

   #and the buttons
   set runB6M [button $mul6.down.action.rB -text "Run Test" \
   -command RunDelayTest6  -width 16]

   button $mul6.down.action.resg -text "Graphic Resuls" \
   -command "NetGRAPH mcl" -width 16
   button $mul6.down.action.resdB -text "Graphic Distributions" \
   -command Distribution -width 16
   button $mul6.down.action.quitB -text "Quit" \
   -command Quit -width 16

   pack $mul6.down.action.rB  $mul6.down.action.resg \
   $mul6.down.action.resdB $mul6.down.action.quitB \
   -anchor n

   #console frame,listbox and scrollbar:
   frame $mul6.down.consoleF
   pack $mul6.down.consoleF -pady 2 -side left \
   -fill x -anchor n -expand true
    set logDelayLB6M [listbox $mul6.down.consoleF.consoleLB \
   -height 7 -font default]

   set csy [scrollbar $mul6.down.consoleF.sY -orient vertical \
   -command "$logDelayLB6M yview"]
   $logDelayLB6M config -yscrollcommand "$csy set"
   pack $csy -fill y -side right
   pack $logDelayLB6M -fill both -side left -expand true

   $flow6MLB delete 0 end
   $flow6MLB see end
   for {set countFL 1} {$countFL <= $flow6M(number)} {incr countFL}  \
   { 
     $flow6MLB insert end [format "Flow  %02d  -  Mods  %02d  -  Heads  %02d  -  %s"  \
     $countFL $mod6M(number,$countFL) $head6M(number,$flow6M(number)) $flow6M(name,$countFL) ]
   }
   $flow6MLB see end
};

###################################################################
#------------------------------------------------------------------
#             ADD Multicast flow6M
#------------------------------------------------------------------
###################################################################
proc AddMflow6 { action } \
{
   global flow6M	    ;# flow data
   global flow6MLB   ;# flow list(box)
   global mod6M	    ;# flow modifier data
   global head6M	    ;# flow modifier data
   global done6	    ;# ok or cancel ?


   if { $action == 0 } \
   {
      incr flow6M(number)
      # VERY usefull when write sequency flows ;)
      if { $flow6M(number) > 1 } \
      {

         set flow6M(name,$flow6M(number))    $flow6M(name,[expr $flow6M(number) - 1]) 
         set flow6M(start,$flow6M(number))   $flow6M(stop,[expr $flow6M(number) - 1]) 
         set flow6M(stop,$flow6M(number))    $flow6M(stop,[expr $flow6M(number) - 1]) 
         set flow6M(port,$flow6M(number))    [expr $flow6M(port,[expr $flow6M(number) - 1]) +1 ]
         set flow6M(pattern,$flow6M(number)) $flow6M(pattern,[expr $flow6M(number) - 1])
         set flow6M(rate,$flow6M(number))    $flow6M(rate,[expr $flow6M(number) - 1]) 
         set flow6M(size,$flow6M(number))    $flow6M(size,[expr $flow6M(number) - 1])  
      } else {
         set    flow6M(start,$flow6M(number)) {}
         set     flow6M(stop,$flow6M(number)) {}
         set     flow6M(port,$flow6M(number)) {}
         set  flow6M(pattern,$flow6M(number)) PERIODIC
         set     flow6M(rate,$flow6M(number)) {}
         set     flow6M(size,$flow6M(number)) {}
      }
      set   mod6M(number,$flow6M(number)) 0
      set  head6M(number,$flow6M(number)) 0
   }

   set done6 not_yet

   #make a dialog window
   toplevel .dialog
   wm title .dialog "IPv6 - Flow No. $flow6M(number)"
   wm resizable .dialog 0 0
   wm protocol .dialog WM_DELETE_WINDOW {;#do nothing}

   #define widgets:
   #frames for standard params, optional
   #params and ok-cancel buttons
   frame .dialog.fr1 -bd 2 -relief groove
   frame .dialog.fr2 -bd 2 -relief groove
   frame .dialog.fr3
   pack .dialog.fr3 -pady 3 -padx 3 -side bottom -anchor c
   pack .dialog.fr1 .dialog.fr2 -fill x -pady 3 -padx 3 -side left \
   -anchor n -expand true


   #standard params
   #(relative) flow start time:
   frame .dialog.fr1.name -bd 2 -relief groove
   pack  .dialog.fr1.name -pady 3 -padx 3 -fill x
   label .dialog.fr1.name.l -text "Flow Name"
   pack  .dialog.fr1.name.l -side top -padx 3
   entry .dialog.fr1.name.e -textvariable flow6M(name,$flow6M(number)) -width 36
   pack  .dialog.fr1.name.e -side bottom -padx 3

   frame .dialog.fr1.fstart
   pack  .dialog.fr1.fstart -pady 3 -fill x
   label .dialog.fr1.fstart.l -text "Flow Start (ms)"
   pack  .dialog.fr1.fstart.l -side left -padx 3
   entry .dialog.fr1.fstart.e -textvariable flow6M(start,$flow6M(number)) \
   -width 20
   pack .dialog.fr1.fstart.e -side right -padx 3

   #(relative) flow stop time
   frame .dialog.fr1.fstop
   pack .dialog.fr1.fstop -pady 3 -fill x
   label .dialog.fr1.fstop.l -text "Flow Stop (ms)"
   pack .dialog.fr1.fstop.l -side left -padx 3
   entry .dialog.fr1.fstop.e -textvariable flow6M(stop,$flow6M(number)) \
   -width 20
   pack .dialog.fr1.fstop.e -side right -padx 3

   #an explanation:
   label .dialog.fr1.exp -text "(Relative to test start)"
   pack .dialog.fr1.exp -padx 3 -pady 2

   #port number. This will be verified at last
   #to have only flows with unique port numbers

   frame .dialog.fr1.fport
   pack .dialog.fr1.fport -pady 3 -fill x
   label .dialog.fr1.fport.l -text "Destination Port"
   pack .dialog.fr1.fport.l -side left -padx 3
   entry .dialog.fr1.fport.e -textvariable flow6M(port,$flow6M(number)) \
   -width 15
   pack .dialog.fr1.fport.e -side right -padx 3

   #pattern type frame, label and radiobuttons
   frame .dialog.fr1.fpattern
   pack .dialog.fr1.fpattern -pady 3 -fill x
   label .dialog.fr1.fpattern.l -text "Pattern"
   pack .dialog.fr1.fpattern.l -side left -padx 3 -fill x
   frame .dialog.fr1.fpattern.rbF -bd 2 -relief groove
   pack .dialog.fr1.fpattern.rbF -padx 3 -pady 3 -side right
   radiobutton .dialog.fr1.fpattern.rbF.rb1 -text PERIODIC \
   -variable flow6M(pattern,$flow6M(number)) -value PERIODIC
   radiobutton .dialog.fr1.fpattern.rbF.rb2 -text POISSON \
   -variable flow6M(pattern,$flow6M(number)) -value POISSON
   pack .dialog.fr1.fpattern.rbF.rb1 .dialog.fr1.fpattern.rbF.rb2 \
   -padx 2 -pady 2 -anchor w

   #rate:
   frame .dialog.fr1.frate
   pack .dialog.fr1.frate -pady 3 -fill x
   label .dialog.fr1.frate.l -text "Rate (packets/sec)"
   pack .dialog.fr1.frate.l -side left -padx 3
   entry .dialog.fr1.frate.e -textvariable flow6M(rate,$flow6M(number)) \
   -width 15
   pack .dialog.fr1.frate.e -side right -padx 3

   #UDP packet payload size
   frame .dialog.fr1.fsize
   pack .dialog.fr1.fsize -pady 3 -fill x
   label .dialog.fr1.fsize.l -text "Packet Size (bytes)"
   pack .dialog.fr1.fsize.l -side left -padx 3
   entry .dialog.fr1.fsize.e -textvariable flow6M(size,$flow6M(number)) \
   -width 15
   pack .dialog.fr1.fsize.e -side right -padx 3

   #ok-cancel buttons on 3rd frame
   button .dialog.fr3.ok -text OK -command {
   set done6 ok
   destroy .dialog
   } -width 6

   button .dialog.fr3.cancel -text Cancel -command {
   set done6 cancel
   destroy .dialog
   } -width 6
   pack .dialog.fr3.ok .dialog.fr3.cancel -side left \
   -padx 3 -pady 3

   grab .dialog
   tkwait window .dialog

   if ![string compare $done6 cancel] {
   #cancel was pressed

   #unset data and decrement number of flows
   foreach elem {start stop port rate pattern size} {
     unset flow6M($elem,$flow6M(number))
   }
   unset  mod6M(number,$flow6M(number))
   unset head6M(number,$flow6M(number))

   incr flow6M(number) -1
   return
   }

   #ok was pressed:

   #first verify that standard parameters are filled

   foreach elem {start stop port rate size} {
     if ![string compare $flow6M($elem,$flow6M(number)) ""] {
         tk_messageBox -message "Missing Flow parameteres...!!"
         AddMflow6 1 
         return
     }
   }

   #check port; must be unique for each flow
   for {set i 1} {$i < $flow6M(number)} {incr i} {
     if {$flow6M(port,$flow6M(number)) == $flow6M(port,$i)} {
         tk_messageBox -message "Port value already used on flow $i"
         AddMflow6 1 
         return
     }
   }

   #data is ok, update listbox:
$flow6MLB insert end [format "Flow  %02d  -  Mods  %02d  -  Heads  %02d  -  %s"  \
$flow6M(number) $mod6M(number,$flow6M(number)) $head6M(number,$flow6M(number)) $flow6M(name,$flow6M(number)) ] 
};

###################################################################
#------------------------------------------------------------------
#             MODify Multicast Flow6
#------------------------------------------------------------------
###################################################################
proc ModifyMflow6 {} \
{

   global flow6M mod6M head6M flow6MLB done6 flow6Nr

   #get the line index
   set flow6Nr [$flow6MLB curselection]

   if {$flow6Nr == ""} {
   #nothing selected
   return
   }
   #else
   incr flow6Nr
   #deal with data
   incr mod6M(number,$flow6Nr)
   set  mod6M(start,$mod6M(number,$flow6Nr),$flow6Nr)   $flow6M(start,$flow6Nr)
   set  mod6M(pattern,$mod6M(number,$flow6Nr),$flow6Nr) $flow6M(pattern,$flow6Nr)
   set  mod6M(rate,$mod6M(number,$flow6Nr),$flow6Nr)    $flow6M(rate,$flow6Nr)
   set  mod6M(size,$mod6M(number,$flow6Nr),$flow6Nr)    $flow6M(size,$flow6Nr)
   set  done6 not_yet

   #make a dialog window
   toplevel .dialog
   wm title .dialog "IPv6 - MODify Flow $flow6Nr"
   wm resizable .dialog 0 0
   wm protocol .dialog WM_DELETE_WINDOW {;#do nothing}

   #define widgets:

   #frames for standard params, optional
   #params and ok-cancel buttons

   frame .dialog.fr1 -bd 2 -relief groove
   frame .dialog.fr2 -bd 2 -relief groove
   frame .dialog.fr3
   pack .dialog.fr3 -pady 3 -padx 3 -side bottom -anchor c
   pack .dialog.fr1 .dialog.fr2 -fill x -pady 3 -padx 3 -side left \
   -anchor n -expand true
   #standard params
   #(relative) flow start time:

   frame .dialog.fr1.fstart
   pack  .dialog.fr1.fstart -pady 3 -fill x
   label .dialog.fr1.fstart.l -text "MODify Flow Start (ms)"
   pack  .dialog.fr1.fstart.l -side left -padx 3
   entry .dialog.fr1.fstart.e -textvariable mod6M(start,$mod6M(number,$flow6Nr),$flow6Nr) \
   -width 10
   pack .dialog.fr1.fstart.e -side right -padx 3

   #an explanation:
   label .dialog.fr1.exp -text "(Relative to test start)"
   pack .dialog.fr1.exp -padx 3 -pady 2

   #pattern type frame, label and radiobuttons
   frame .dialog.fr1.fpattern
   pack .dialog.fr1.fpattern -pady 3 -fill x
   label .dialog.fr1.fpattern.l -text "Pattern"
   pack .dialog.fr1.fpattern.l -side left -padx 3 -fill x
   frame .dialog.fr1.fpattern.rbF -bd 2 -relief groove
   pack .dialog.fr1.fpattern.rbF -padx 3 -pady 3 -side right
   radiobutton .dialog.fr1.fpattern.rbF.rb1 -text PERIODIC \
   -variable mod6M(pattern,$mod6M(number,$flow6Nr),$flow6Nr)  -value PERIODIC
   radiobutton .dialog.fr1.fpattern.rbF.rb2 -text POISSON \
   -variable mod6M(pattern,$mod6M(number,$flow6Nr),$flow6Nr)  -value POISSON
   pack .dialog.fr1.fpattern.rbF.rb1 .dialog.fr1.fpattern.rbF.rb2 \
   -padx 2 -pady 2 -anchor w

   #rate:

   frame .dialog.fr1.frate
   pack .dialog.fr1.frate -pady 3 -fill x
   label .dialog.fr1.frate.l -text "Rate (packets/sec)"
   pack .dialog.fr1.frate.l -side left -padx 3
   entry .dialog.fr1.frate.e -textvariable mod6M(rate,$mod6M(number,$flow6Nr),$flow6Nr) \
   -width 10
   pack .dialog.fr1.frate.e -side right -padx 3

   #UDP packet payload size
   frame .dialog.fr1.fsize
   pack .dialog.fr1.fsize -pady 3 -fill x
   label .dialog.fr1.fsize.l -text "Packet Size (bytes)"
   pack .dialog.fr1.fsize.l -side left -padx 3
   entry .dialog.fr1.fsize.e -textvariable mod6M(size,$mod6M(number,$flow6Nr),$flow6Nr) \
   -width 10
   pack .dialog.fr1.fsize.e -side right -padx 3


   #ok-cancel buttons on 3rd frame
   button .dialog.fr3.ok -text OK -command {
   set done6 ok
   destroy .dialog
   } -width 6

   button .dialog.fr3.cancel -text Cancel -command {
   set done6 cancel
   destroy .dialog
   } -width 6
   pack .dialog.fr3.ok .dialog.fr3.cancel -side left \
   -padx 3 -pady 3

   grab .dialog
   tkwait window .dialog

   if ![string compare $done6 cancel] {
   #cancel was pressed

   #unset data and decrement number of flows
   foreach elem {start rate pattern size } {
   unset mod6M($elem,$mod6M(number,$flow6Nr),$flow6Nr)
   }
   incr mod6M(number,$flow6Nr) -1
   return
   }

   #ok was pressed:

   #first verify that standard parameters are filled

   foreach elem {start rate size} {
   if ![string compare $mod6M($elem,$mod6M(number,$flow6Nr),$flow6Nr) ""] {

   tk_messageBox -message "Flow MOD not added"
   #unset data and decrement number of flows
   foreach elem {start rate pattern size } {
   unset mod6M($elem,$mod6M(number,$flow6Nr),$flow6Nr)
   }

   incr mod6M(number,$flow6Nr) -1
   return

   };#end if
   };#end foreach

   #in this point, data is ok
   #update listbox:

   $flow6MLB delete [expr $flow6Nr - 1]
   $flow6MLB insert [expr $flow6Nr - 1] [format "Flow  %02d  -  Mods  %02d  -  Heads  %02d  -  %s"  \
   $flow6Nr $mod6M(number,$flow6Nr) $head6M(number,$flow6Nr) $flow6M(name,$flow6Nr) ] 
};

###################################################################
#------------------------------------------------------------------
#                      DELETE Multicast LAST FLOW
#------------------------------------------------------------------
###################################################################
proc DeleteMflow6 {} \
{
   global flow6M mod6M flow6MLB head6M
   global xflowview6
   global userLB6M


   #check number of flows:
   if !$flow6M(number) {
      return
   }
   if  { $xflowview6 == $flow6M(number) } \
   {
      $userLB6M delete 0 end
   }

   #first, delete all the mod data associated with the flow:
   for {set i 1} {$i <= $mod6M(number,$flow6M(number))} {incr i} {
      foreach elem {start rate pattern size } \
      {
         unset mod6M($elem,$i,$flow6M(number))
      };
   };
   #unset mod6M counter:
   unset mod6M(number,$flow6M(number))

   #second, delete all the extension header associated with the flow:
   for {set i 1} {$i <= $head6M(number,$flow6M(number))} {incr i} {
      #tk_messageBox -message "option =  $head6M(option,$i,$flow6M(number))"
      #tk_messageBox -message "data  =   $head6M(data,$i,$flow6M(number))"
      foreach elem {  start stop data option } \
      {
         unset head6M($elem,$i,$flow6M(number))
      }
   };
   #unset head6M counter:
   unset head6M(number,$flow6M(number))

   #then, delete the flow (last flow)
   foreach elem {start stop port rate pattern size } {
      unset flow6M($elem,$flow6M(number))
   };
   #decrement flow number
   incr flow6M(number) -1

   #update listbox
   $flow6MLB delete end end
};

###################################################################
#------------------------------------------------------------------
#         sub-procedure in ADDHeader IPv6
#------------------------------------------------------------------
###################################################################
proc update_m_header_option {} \
{
   global  opt  .dialog

   pack forget .dialog.fr1.update
   pack forget .dialog.fr1.jumbo
   pack forget .dialog.fr1.req
   pack forget .dialog.fr1.ack
   pack forget .dialog.fr1.home
   pack forget .dialog.fr1.routing
   pack forget .dialog.fr1.alert

   switch $opt \
   {
      BINDING_UPDATE { pack .dialog.fr1.update -anchor n -fill x -pady 3 -padx 3 }
      BINDING_ACK    { pack .dialog.fr1.ack -anchor n -fill x -pady 3    -padx 3 }
      BINDING_REQ    { pack .dialog.fr1.req -anchor n -fill x -pady 3   -padx 3  }
      ROUTING_HEADER { pack .dialog.fr1.routing -anchor n -fill x -pady 3 -padx 3}
      HOME_ADDRESS_OPTION  { pack .dialog.fr1.home -anchor n -fill x -pady 3  -padx 3  }
      ROUTER_ALERT_OPTION  { pack .dialog.fr1.alert -anchor n -fill x -pady 3 -padx 3  }
      JUMBO_PAYLOAD_OPTION { pack .dialog.fr1.jumbo -anchor n -fill x -pady 3 -padx 3  }
   }
}

###################################################################
#------------------------------------------------------------------
#          Add options for extensions headers (mobile ipv6)
#------------------------------------------------------------------
###################################################################
proc AddMHeader6 {} \
{
   #(mobile ipv6)
   global flow6M head6M flow6MLB done6 flow6Nr
   global opt mod6M

   #get the line index
   set flow6Nr [$flow6MLB curselection]

   if {$flow6Nr == ""} {
      #nothing selected
      return
   }
   #else
   incr flow6Nr
   #deal with data

   incr head6M(number,$flow6Nr)

   #no port choice; is better that one flow has just one port
   set  head6M(start,$head6M(number,$flow6Nr),$flow6Nr) $flow6M(start,$flow6Nr)
   set  head6M(stop,$head6M(number,$flow6Nr),$flow6Nr)  $flow6M(stop,$flow6Nr)
   set  head6M(option,$head6M(number,$flow6Nr),$flow6Nr) ""
   set  head6M(data,$head6M(number,$flow6Nr),$flow6Nr) ""

   set done6 not_yet
   #make a dialog window
   toplevel .dialog
   wm title .dialog "IPv6 - Add option: Flow $flow6Nr"
   wm resizable .dialog 0 0
   wm protocol .dialog WM_DELETE_WINDOW {;#do nothing}

   #define widgets:
   #frames for standard params, optional
   #params and ok-cancel buttons
   frame .dialog.fr1 -bd 2 -relief groove
   frame .dialog.fr2 -bd 2 -relief groove
   frame .dialog.fr3

   pack .dialog.fr3 -pady 3 -padx 3 -side bottom -anchor c
   pack .dialog.fr1 .dialog.fr2 -fill x -pady 3 -padx 3 -side left \
   -anchor n -expand true

   #standard params
   #(relative) flow start time:
   frame .dialog.fr1.fstart
   pack .dialog.fr1.fstart -pady 3 -fill x
   label .dialog.fr1.fstart.l -text "Option start time (ms)"
   pack .dialog.fr1.fstart.l -side left -padx 3
   entry .dialog.fr1.fstart.e -textvariable head6M(start,$head6M(number,$flow6Nr),$flow6Nr) \
   -width 20
   pack .dialog.fr1.fstart.e -side right -padx 3

   frame .dialog.fr1.fstop
   pack .dialog.fr1.fstop -pady 3 -fill x
   label .dialog.fr1.fstop.l -text "Option stop time (ms)"
   pack .dialog.fr1.fstop.l -side left -padx 3
   entry .dialog.fr1.fstop.e -textvariable head6M(stop,$head6M(number,$flow6Nr),$flow6Nr) \
   -width 20
   pack .dialog.fr1.fstop.e -side right -padx 3

   frame .dialog.fr1.head
   pack .dialog.fr1.head -pady 3 -fill x
   label .dialog.fr1.head.l -text "Select the\n option header"
   pack .dialog.fr1.head.l -side left -padx 3 -fill x
   frame .dialog.fr1.head.rbF -bd 2 -relief groove
   pack .dialog.fr1.head.rbF -padx 3 -pady 3 -side right

   set  opt "BINDING_UPDATE"
   radiobutton .dialog.fr1.head.rbF.rb0 -text "Binding update" \
   -variable opt  -value "BINDING_UPDATE" -command { update_m_header_option }
   radiobutton .dialog.fr1.head.rbF.rb1 -text "Binding ack" \
   -variable opt  -value "BINDING_ACK" -command { update_m_header_option }
   radiobutton .dialog.fr1.head.rbF.rb2 -text "Binding request" \
   -variable opt  -value "BINDING_REQ" -command { update_m_header_option }
   radiobutton .dialog.fr1.head.rbF.rb3 -text "Routing header" \
   -variable opt  -value "ROUTING_HEADER" -command { update_m_header_option }
   radiobutton .dialog.fr1.head.rbF.rb4 -text "Home Address" \
   -variable opt  -value "HOME_ADDRESS_OPTION" -command { update_m_header_option }
   radiobutton .dialog.fr1.head.rbF.rb5 -text "Router alert" \
   -variable opt  -value "ROUTER_ALERT_OPTION" -command { update_m_header_option }
   radiobutton .dialog.fr1.head.rbF.rb6 -text "Jumbo payload" \
   -variable opt  -value "JUMBO_PAYLOAD_OPTION" -command { update_m_header_option }

   pack .dialog.fr1.head.rbF.rb0  \
        .dialog.fr1.head.rbF.rb1  .dialog.fr1.head.rbF.rb2 \
        .dialog.fr1.head.rbF.rb3  .dialog.fr1.head.rbF.rb4 \
        .dialog.fr1.head.rbF.rb3  .dialog.fr1.head.rbF.rb4 \
        .dialog.fr1.head.rbF.rb5  .dialog.fr1.head.rbF.rb6 \
   -padx 2 -pady 2 -anchor w

   #no need to pack it, see radiobutton command
   frame .dialog.fr1.jumbo
   label .dialog.fr1.jumbo.l -text "Jumbo payload (bytes)"
   pack  .dialog.fr1.jumbo.l -side left -padx 3
   entry .dialog.fr1.jumbo.e -textvariable head6M(data,$head6M(number,$flow6Nr),$flow6Nr) -width 15
   pack  .dialog.fr1.jumbo.e -side right -padx 3

   #no need to pack it, see radiobutton command
   frame .dialog.fr1.alert
   label .dialog.fr1.alert.l -text "Router Alert "
   pack  .dialog.fr1.alert.l -side left -padx 3
   #no need to pack it, see radiobutton command
   frame .dialog.fr1.req
   label .dialog.fr1.req.l -text "Binding Request"
   pack  .dialog.fr1.req.l -side left -padx 3

   #no need to pack it, see radiobutton command
   frame .dialog.fr1.ack
   label .dialog.fr1.ack.l -text "(status lifetime refresh)"
   pack  .dialog.fr1.ack.l -side left -padx 3
   entry .dialog.fr1.ack.e -textvariable head6M(data,$head6M(number,$flow6Nr),$flow6Nr) -width 17
   pack  .dialog.fr1.ack.e -side right -padx 3

   #no need to pack it, see radiobutton command
   frame .dialog.fr1.update
   label .dialog.fr1.update.l -text "(prefix lifetime COA)"
   pack  .dialog.fr1.update.l -side left -padx 3
   entry .dialog.fr1.update.e -textvariable head6M(data,$head6M(number,$flow6Nr),$flow6Nr) -width 17
   pack  .dialog.fr1.update.e -side right -padx 3

   #no need to pack it, see radiobutton command
   frame .dialog.fr1.home
   label .dialog.fr1.home.l -text "home address"
   pack  .dialog.fr1.home.l -side left -padx 3
   entry .dialog.fr1.home.e -textvariable head6M(data,$head6M(number,$flow6Nr),$flow6Nr) -width 20
   pack  .dialog.fr1.home.e -side right -padx 3

   #no need to pack it, see radiobutton command
   frame .dialog.fr1.routing
   label .dialog.fr1.routing.l -text "routing header"
   pack  .dialog.fr1.routing.l -side left -padx 3
   entry .dialog.fr1.routing.e -textvariable head6M(data,$head6M(number,$flow6Nr),$flow6Nr) -width 20
   pack  .dialog.fr1.routing.e -side right -padx 3

   #update window with the current entry by value of $opt
   update_m_header_option

   #ok-cancel buttons on 3rd frame
   button .dialog.fr3.ok -text OK -command \
   {
      set done6 ok
      destroy .dialog
   } -width 6
   button .dialog.fr3.cancel -text Cancel -command \
   {
      set done6 cancel
      destroy .dialog
   } -width 6
   pack .dialog.fr3.ok .dialog.fr3.cancel -side left \
   -padx 3 -pady 3
   grab .dialog
   tkwait window .dialog

   set  head6M(option,$head6M(number,$flow6Nr),$flow6Nr) $opt

   #test
   #tk_messageBox -message "option =  $head6M(option,$head6M(number,$flow6Nr),$flow6Nr)"
   #tk_messageBox -message "data   =  $head6M(data,$head6M(number,$flow6Nr),$flow6Nr)"

   if ![string compare $done6 cancel] \
   {
      #cancel was pressed
      #unset data and decrement number of flows
      foreach elem {  start stop data option } \
      {
           unset head6M($elem,$head6M(number,$flow6Nr),$flow6Nr)
      }
      incr head6M(number,$flow6Nr) -1
      return
   }
   #ok was pressed:
   #first verify that standard parameters are filled
   foreach elem {start stop} \
   {
      if ![string compare $head6M($elem,$head6M(number,$flow6Nr),$flow6Nr) ""] \
      {
         tk_messageBox -message "Option not added"
         #unset data and decrement number of flows
         foreach elem {  start stop data option } \
         {
              unset head6M($elem,$head6M(number,$flow6Nr),$flow6Nr)
         }
         incr head6M(number,$flow6Nr) -1
         return
      }
   }
   #update listbox:
   $flow6MLB delete [expr $flow6Nr - 1]
   $flow6MLB insert [expr $flow6Nr - 1] [format "Flow  %02d  -  Mods  %02d  -  Heads  %02d  -  %s"  \
   $flow6Nr $mod6M(number,$flow6Nr) $head6M(number,$flow6Nr) $flow6M(name,$flow6Nr) ] 
}

###################################################################
#------------------------------------------------------------------
#             View Multicast flow6M
#------------------------------------------------------------------
###################################################################
proc ViewMflow6 {} \
{
   global userLB6M head6M
   global flow6M mod6M flow6MLB
   global xflowview6


   set flow6Nr [$flow6MLB curselection]
   #tk_messageBox -message "fnr = $flow6Nr"  
   if {$flow6Nr == ""} {
   #nothing selected
   return
   }
   incr flow6Nr
   set  xflowview6 $flow6Nr

   $userLB6M delete 0 end
   $userLB6M insert end "Flow number (ID): $flow6Nr"
   $userLB6M insert end "Flow name: $flow6M(name,$flow6Nr)"
   $userLB6M insert end "Start time (ON): $flow6M(start,$flow6Nr)"
   $userLB6M insert end "Stop time (OFF): $flow6M(stop,$flow6Nr)"
   $userLB6M insert end "Destination port number: $flow6M(port,$flow6Nr)"
   $userLB6M insert end "Rate (packets/sec): $flow6M(rate,$flow6Nr)"
   $userLB6M insert end "Pattern: $flow6M(pattern,$flow6Nr)"
   $userLB6M insert end "UDP packet payload size: $flow6M(size,$flow6Nr)"
   #mod6M data:
   for {set i 1} {$i <= $mod6M(number,$flow6Nr)} {incr i} {
      $userLB6M insert end "-------------------------------------------------------"
      $userLB6M insert end "Modify flow n. $i"
      $userLB6M insert end "Start time: $mod6M(start,$i,$flow6Nr)"
      $userLB6M insert end "Rate:  $mod6M(rate,$i,$flow6Nr)"
      $userLB6M insert end "Pattern  $mod6M(pattern,$i,$flow6Nr)"
      $userLB6M insert end "UDP packet payload size:  $mod6M(size,$i,$flow6Nr)"
   };
   #head6M data:
   for {set i 1} {$i <= $head6M(number,$flow6Nr)} {incr i} {
      $userLB6M insert end "-------------------------------------------------------"
      $userLB6M insert end "Extension header n. $i"
      $userLB6M insert end "Start time: $head6M(start,$i,$flow6Nr)"
      $userLB6M insert end "Stop  time: $head6M(stop,$i,$flow6Nr)"
      $userLB6M insert end "IPv6 option: $head6M(option,$i,$flow6Nr)"
      $userLB6M insert end "value (if need): $head6M(data,$i,$flow6Nr)"
   };
   $userLB6M see end
}

###################################################################
#------------------------------------------------------------------
#             Add Multicast Parmaeter6
#------------------------------------------------------------------
###################################################################
proc AddParameterM6 {} \
{
	global done paramName paramValue
	global paramM6 pM6 countPM6
	global mul6

	set paramName  ""
	set paramValue ""

	toplevel .addpu6
	wm title .addpu6 "Add Parameter"
	wm resizable .addpu6 0 0
	wm protocol  .addpu6 WM_DELETE_WINDOW {;#do nothing}
	frame .addpu6.nameF
	frame .addpu6.valueF
	frame .addpu6.buttonsF
	pack  .addpu6.nameF .addpu6.valueF .addpu6.buttonsF -pady 3

	#name
	label .addpu6.nameF.nameL -text "Name"
	entry .addpu6.nameF.nameE -textvariable paramName  -width 45
	pack  .addpu6.nameF.nameL -side left -padx 2
	pack  .addpu6.nameF.nameE -side right -padx 2

	#value
	label .addpu6.valueF.valueL -text "Value"
	entry .addpu6.valueF.valueE -textvariable paramValue  -width 45
	pack  .addpu6.valueF.valueL -side left -padx 2
	pack  .addpu6.valueF.valueE -side right -padx 2

	#buttons
	button .addpu6.buttonsF.okB -text OK -command {set done ok}
	button .addpu6.buttonsF.cancelB -text Cancel -command {set done cancel}
	pack  .addpu6.buttonsF.okB .addpu6.buttonsF.cancelB  -side left -anchor c -expand true

	set done not_yet
	grab .addpu6
	tkwait variable done
	grab release .addpu6
	destroy .addpu6

	#OK or Cancel pressed, at this point
	if {![string compare $done ok]} \
	{
		if {![string compare "" [string trim $paramName]]} \
		{
			#nothing eligible was specified
			return
		}
		incr countPM6
		set tmp "$paramName: $paramValue"
		set paramM6($tmp) $countPM6
		set pM6 "$tmp"

		destroy  $mul6.up.right.custom.b.bx
		eval tk_optionMenu $mul6.up.right.custom.b.bx pM6 [lsort [array names paramM6 ]]
		$mul6.up.right.custom.b.bx configure -width 20
		pack    $mul6.up.right.custom.b.bx  -side left
	}
}

###################################################################
#------------------------------------------------------------------
#             Remove Parameter U6
#------------------------------------------------------------------
###################################################################
proc RemoveParameterM6 {} \
{
	global paramM6 pM6 countPM6
	global mul6

	if ![string compare $pM6 "(parameters)"] \
	{
		return
		#nothing selected
	}
	unset paramM6($pM6)
	set pM6 "(parameters)"
	destroy  $mul6.up.right.custom.b.bx
	eval tk_optionMenu $mul6.up.right.custom.b.bx pM6 [lsort [array names paramM6 ]]
	$mul6.up.right.custom.b.bx configure -width 20
	pack     $mul6.up.right.custom.b.bx  -side left
	incr countPM6 -1
}

###################################################################
#------------------------------------------------------------------
#             Edit Parameter U6
#------------------------------------------------------------------
###################################################################
proc EditParameterM6 {} \
{
	global done paramName paramValue
	global paramM6 pM6 countPM6
	global mul6


	if ![string compare $pM6 "(parameters)"] \
	{
		return
		#nothing selected
	}

	set line $pM6
	set lindex     [string first : $line 0]
	set paramName  [string range   $line 0 [expr $lindex]]
	set paramValue [string range   $line   [expr $lindex +2]  [string length $line]]

	toplevel .dialog
	wm title .dialog "Edit Parameter"
	wm resizable .dialog 0 0
	wm protocol .dialog WM_DELETE_WINDOW {;#do nothing}

	label .dialog.titleL -text "Insert New Value"
	frame .dialog.paramF
	frame .dialog.buttonsF
	pack .dialog.titleL .dialog.paramF .dialog.buttonsF -pady 3
	label .dialog.paramF.numeL -text "$paramName"

	entry .dialog.paramF.valueE -textvariable paramValue -width 45
	pack .dialog.paramF.numeL -side left -padx 2
	pack .dialog.paramF.valueE -side right -padx 2
	button .dialog.buttonsF.okB -text OK -command {set done ok}
	button .dialog.buttonsF.cancelB -text Cancel -command {set done cancel}
	pack .dialog.buttonsF.okB .dialog.buttonsF.cancelB -side left \
	-anchor c -padx 5
	set done not_yet
	grab .dialog
	tkwait variable done
	grab release .dialog
	destroy .dialog

	if {![string compare $done ok]} \
	{
		unset paramM6($pM6)
		set tmp "$paramName $paramValue"
		set paramM6($tmp) $countPM6
		set pM6 "$tmp"

		destroy  $mul6.up.right.custom.b.bx
		eval tk_optionMenu $mul6.up.right.custom.b.bx pM6 [lsort [array names paramM6 ]]
		$mul6.up.right.custom.b.bx configure -width 20
		pack    $mul6.up.right.custom.b.bx  -side left
	}
}

###################################################################
#------------------------------------------------------------------
#             EditFlow 6
#------------------------------------------------------------------
###################################################################
proc EditMflow6 { action } \
{
   global flow6M	    ;# flow data
   global flow6MLB   ;# flow list(box)
   global mod6M	    ;# flow modifier data
   global head6M	    ;# flow modifier data

   if { $action == 0 } \
   {
      set flow6Nr [$flow6MLB curselection]
      if {$flow6Nr == ""} {
        tk_messageBox -message "Select Flow...!!"
        #nothing selected
        return
      }
      incr flow6Nr
   } else { 
      set flow6Nr $action
   }
   set done6 not_yet

   #make a dialog window
   toplevel .dialog
   wm title .dialog "IPv6 - Edit Flow No. $flow6Nr"
   wm resizable .dialog 0 0
   wm protocol .dialog WM_DELETE_WINDOW {;#do nothing}

   #define widgets:
   #frames for standard params, optional
   #params and ok-cancel buttons
   frame .dialog.fr1 -bd 2 -relief groove
   frame .dialog.fr2 -bd 2 -relief groove
   frame .dialog.fr3
   pack .dialog.fr3 -pady 3 -padx 3 -side bottom -anchor c
   pack .dialog.fr1 .dialog.fr2 -fill x -pady 3 -padx 3 -side left \
   -anchor n -expand true

   #standard params
   #(relative) flow start time:

   frame .dialog.fr1.name -bd 2 -relief groove
   pack  .dialog.fr1.name -pady 3 -padx 3 -fill x
   label .dialog.fr1.name.l -text "Flow Name"
   pack  .dialog.fr1.name.l -side top -padx 3
   entry .dialog.fr1.name.e -textvariable flow6M(name,$flow6Nr) -width 36
   pack  .dialog.fr1.name.e -side bottom -padx 3

   frame .dialog.fr1.fstart
   pack .dialog.fr1.fstart -pady 3 -fill x
   label .dialog.fr1.fstart.l -text "Flow Start (ms)"
   pack .dialog.fr1.fstart.l -side left -padx 3
   entry .dialog.fr1.fstart.e -textvariable flow6M(start,$flow6Nr) \
   -width 20
   pack .dialog.fr1.fstart.e -side right -padx 3

   #(relative) flow stop time
   frame .dialog.fr1.fstop
   pack .dialog.fr1.fstop -pady 3 -fill x
   label .dialog.fr1.fstop.l -text "Flow Stop (ms)"
   pack .dialog.fr1.fstop.l -side left -padx 3
   entry .dialog.fr1.fstop.e -textvariable flow6M(stop,$flow6Nr) \
   -width 20
   pack .dialog.fr1.fstop.e -side right -padx 3

   #an explanation:
   label .dialog.fr1.exp -text "(Relative to test start)"
   pack .dialog.fr1.exp -padx 3 -pady 2

   #port number. This will be verified at last
   #to have only flows with unique port numbers

   frame .dialog.fr1.fport
   pack .dialog.fr1.fport -pady 3 -fill x
   label .dialog.fr1.fport.l -text "Destination Port"
   pack .dialog.fr1.fport.l -side left -padx 3
   entry .dialog.fr1.fport.e -textvariable flow6M(port,$flow6Nr) \
   -width 15
   pack .dialog.fr1.fport.e -side right -padx 3

   #pattern type frame, label and radiobuttons
   frame .dialog.fr1.fpattern
   pack .dialog.fr1.fpattern -pady 3 -fill x
   label .dialog.fr1.fpattern.l -text "Pattern"
   pack .dialog.fr1.fpattern.l -side left -padx 3 -fill x
   frame .dialog.fr1.fpattern.rbF -bd 2 -relief groove
   pack .dialog.fr1.fpattern.rbF -padx 3 -pady 3 -side right
   radiobutton .dialog.fr1.fpattern.rbF.rb1 -text PERIODIC \
   -variable flow6M(pattern,$flow6Nr) -value PERIODIC
   radiobutton .dialog.fr1.fpattern.rbF.rb2 -text POISSON \
   -variable flow6M(pattern,$flow6Nr) -value POISSON
   pack .dialog.fr1.fpattern.rbF.rb1 .dialog.fr1.fpattern.rbF.rb2 \
   -padx 2 -pady 2 -anchor w

   #rate:
   frame .dialog.fr1.frate
   pack .dialog.fr1.frate -pady 3 -fill x
   label .dialog.fr1.frate.l -text "Rate (packets/sec)"
   pack .dialog.fr1.frate.l -side left -padx 3
   entry .dialog.fr1.frate.e -textvariable flow6M(rate,$flow6Nr) \
   -width 15
   pack .dialog.fr1.frate.e -side right -padx 3

   #UDP packet payload size
   frame .dialog.fr1.fsize
   pack .dialog.fr1.fsize -pady 3 -fill x
   label .dialog.fr1.fsize.l -text "Packet Size (bytes)"
   pack .dialog.fr1.fsize.l -side left -padx 3
   entry .dialog.fr1.fsize.e -textvariable flow6M(size,$flow6Nr) \
   -width 15
   pack .dialog.fr1.fsize.e -side right -padx 3

   #ok-cancel buttons on 3rd frame
   button .dialog.fr3.ok -text OK -command {
   set done6 ok
   destroy .dialog
   } -width 6

   button .dialog.fr3.cancel -text Cancel -command {
   set done6 cancel
   destroy .dialog
   } -width 6
   pack .dialog.fr3.ok .dialog.fr3.cancel -side left \
   -padx 3 -pady 3

   grab .dialog
   tkwait window .dialog

   #cancel was pressed
   if ![string compare $done6 cancel] { return  }

   #ok was pressed:
   #first verify that standard parameters are filled

   foreach elem {start stop port rate size} {
     if ![string compare $flow6M($elem,$flow6Nr) ""] {
         tk_messageBox -message "Missing Flow parameteres...!!"
         EditMflow6 1 
         return
     }
   }

   #check port; must be unique for each flow
   for {set i 1} {$i < $flow6M(number)} {incr i} {
     if {$flow6M(port,$flow6Nr) == $flow6M(port,$i)  && $flow6Nr != $i } {
         tk_messageBox -message "Port value already used on flow $i"
         EditMflow6 1 
         return
     }
   }
   $flow6MLB delete [expr $flow6Nr - 1]
   $flow6MLB insert [expr $flow6Nr - 1] [format "Flow  %02d  -  Mods  %02d  -  Heads  %02d  -  %s"  \
		$flow6Nr $mod6M(number,$flow6Nr) $head6M(number,$flow6Nr) $flow6M(name,$flow6Nr) ] 
}

