###############################################
# Copyright 2002, 2003 Ren Serral,           #
#                      Roberto Borgione       #
# thru4.tcl - Unicast Throughput IPv4         #
#       v2.0 (04-2002)                        #
#       v2.01(02-2003)                        #
###############################################

#   This file is part of NetMeter.
#
#   NetMeter is free software; you can redistribute it and/or modify
#   it under the terms of the GNU General Public License as published by
#   the Free Software Foundation; either version 2 of the License, or
#   (at your option) any later version.
#
#   NetMeter is distributed in the hope that it will be useful,
#   but WITHOUT ANY WARRANTY; without even the implied warranty of
#   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#   GNU General Public License for more details.
#
#   You should have received a copy of the GNU General Public License
#   along with NetMeter; if not, write to the Free Software
#   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

####################################################################
# ------------------------------------------------------------------
#	             Netperf IPv4
# ------------------------------------------------------------------
####################################################################
proc Throughput:Tu4 {}\
{
   global u4tF
   global sndF rcvF tF lF cF y z4
   global customparams customEnd
   global npf


   frame $u4tF.paramF
   frame $u4tF.consoleF
   pack $u4tF.paramF $u4tF.consoleF -fill x
   frame $u4tF.paramF.standardF -bd 2 -relief groove
   set cF [frame $u4tF.paramF.customF -bd 2 -relief groove]
   pack  $u4tF.paramF.standardF $u4tF.paramF.customF -side left \
     -fill both -padx 2 -pady 2 -expand true

   label $u4tF.paramF.standardF.titleL -text "IPv4 - Netperf Options" -relief raised
   pack  $u4tF.paramF.standardF.titleL -anchor c  -fill x -padx 3 -pady 3

   frame $u4tF.paramF.standardF.title
   pack  $u4tF.paramF.standardF.title -pady 2 -fill x
   label $u4tF.paramF.standardF.title.l -text "Title measure"
   pack  $u4tF.paramF.standardF.title.l -side left -padx 3
   entry $u4tF.paramF.standardF.title.e -textvariable npf(title) -width 25
   pack  $u4tF.paramF.standardF.title.e -side right -padx 3


   frame $u4tF.paramF.standardF.dF
   pack  $u4tF.paramF.standardF.dF -fill x -pady 2
   set sndF [frame $u4tF.paramF.standardF.dF.sendF -bd 2 -relief groove]
   set rcvF [frame $u4tF.paramF.standardF.dF.recvF -bd 2 -relief groove]
   pack $sndF $rcvF -padx 2 -pady 2 -fill x -anchor n
   label $sndF.senderL -text Sender
   pack  $sndF.senderL -pady 2 -anchor c

   ##########################################
   # Check-Button parameters Netperf
   #########################################

   #(send) message size option:
   frame $sndF.smessageF
   pack $sndF.smessageF -pady 2 -fill x
   checkbutton $sndF.smessageF.smC -variable npf(sendMessageSizeBool) \
     -text "Send Message Size" -command {
       if $npf(sendMessageSizeBool) {
          $u4tF.paramF.standardF.dF.sendF.smessageF.smE config -state normal -fg black
       } else {
          $u4tF.paramF.standardF.dF.sendF.smessageF.smE config -state disabled -fg gray
       }
     }
   pack $sndF.smessageF.smC -side left -fill x -padx 2
   #update state with the value of the Bool
   if $npf(sendMessageSizeBool) {
       entry $sndF.smessageF.smE -textvariable npf(sendMessageSize)  \
         -state normal -width 10
#       $sndF.smessageF.smE config -state normal -fg black
   } else {
       entry $sndF.smessageF.smE -textvariable npf(sendMessageSize)  \
         -state disabled -fg gray -width 10
#       $sndF.smessageF.smE config -state disabled -fg gray
   }
   pack $sndF.smessageF.smE -side right -fill x -padx 2
   #send socket size option
   frame $sndF.ssocketF
   pack $sndF.ssocketF -pady 2 -fill x
   entry $sndF.ssocketF.ssE -textvariable npf(sendSocketSize)  \
     -state disabled -fg gray -width 10
   checkbutton $sndF.ssocketF.ssC -text "Send Socket Size" \
     -variable npf(sendSocketSizeBool) -command {
      if $npf(sendSocketSizeBool) {
          $u4tF.paramF.standardF.dF.sendF.ssocketF.ssE configure -state normal -fg black
      } else {
          $u4tF.paramF.standardF.dF.sendF.ssocketF.ssE configure  -state disabled -fg gray
      }
   }
   #update state with the value of the Bool
   if $npf(sendSocketSizeBool) {
       $sndF.ssocketF.ssE configure -state normal -fg black
   } else {
       $sndF.ssocketF.ssE configure  -state disabled -fg gray
   }
   pack $sndF.ssocketF.ssC -side left -fill x -padx 2
   pack $sndF.ssocketF.ssE -side right -fill x -padx 2
   #specify port:
   frame $sndF.sportF
   pack $sndF.sportF -pady 2 -fill x
   entry $sndF.sportF.spE -textvariable npf(portNumber)  \
     -state disabled -fg gray -width 10
   checkbutton $sndF.sportF.spC -text "Port Number" \
     -variable npf(portNumberBool) -command {
       if $npf(portNumberBool) {
          $u4tF.paramF.standardF.dF.sendF.sportF.spE configure -state normal -fg black
       } else {
          $u4tF.paramF.standardF.dF.sendF.sportF.spE configure  -state disabled -fg gray
       }
     }
   #update state with the value of the Bool
   if $npf(portNumberBool) {
       $sndF.sportF.spE configure -state normal -fg black
   } else {
       $sndF.sportF.spE configure  -state disabled -fg gray
   }
   pack $sndF.sportF.spC -side left -fill x -padx 2
   pack $sndF.sportF.spE -side right -fill x -padx 2
   ##receiver related widgets
   #section title
   label $rcvF.recvL -text Receiver
   pack $rcvF.recvL -pady 2 -anchor c
   #(receive) message size option:
   frame $rcvF.rmessageF
   pack $rcvF.rmessageF -pady 2 -fill x
   entry $rcvF.rmessageF.rmE -textvariable npf(recvMessageSize)  \
   -state disabled -fg gray -width 10
   checkbutton $rcvF.rmessageF.rmC -text "Recv Message Size" \
     -variable npf(recvMessageSizeBool) -command {
       if $npf(recvMessageSizeBool) {
          $u4tF.paramF.standardF.dF.recvF.rmessageF.rmE configure -state normal -fg black
       } else {
          $u4tF.paramF.standardF.dF.recvF.rmessageF.rmE configure  -state disabled -fg gray
       }
     }
   #update state with the value of the Bool
   if $npf(recvMessageSizeBool) {
       $rcvF.rmessageF.rmE configure -state normal -fg black
   } else {
       $rcvF.rmessageF.rmE configure  -state disabled -fg gray
   }
   pack $rcvF.rmessageF.rmC -side left -fill x -padx 2
   pack $rcvF.rmessageF.rmE -side right -fill x -padx 2
   #receive socket size option
   frame $rcvF.rsocketF
   pack $rcvF.rsocketF -pady 2 -fill x
   entry $rcvF.rsocketF.rsE -textvariable npf(recvSocketSize)  \
     -state disabled -fg gray -width 10
   checkbutton $rcvF.rsocketF.rsC -text "Recv Socket Size" \
     -variable npf(recvSocketSizeBool) -command \
     {
       if $npf(recvSocketSizeBool) {
          $u4tF.paramF.standardF.dF.recvF.rsocketF.rsE configure -state normal -fg black
       } else {
          $u4tF.paramF.standardF.dF.recvF.rsocketF.rsE configure  -state disabled -fg gray
       }
     }
   #update state with the value of the Bool
   if $npf(recvSocketSizeBool) {
       $rcvF.rsocketF.rsE configure -state normal -fg black
   } else {
       $rcvF.rsocketF.rsE configure  -state disabled -fg gray
   }
   pack $rcvF.rsocketF.rsC -side left -fill x -padx 2
   pack $rcvF.rsocketF.rsE -side right -fill x -padx 2

   ##test type, tcp_nodelay and test length widgets test length (duration)
   set lF [frame $u4tF.paramF.standardF.lengthF -bd 2 -relief groove]
   pack  $lF -padx 2 -pady 2 -fill x
   frame $lF.leF
   pack  $lF.leF -pady 2 -side left -expand true
   label $lF.leF.lnL -text "Test Duration"
   entry $lF.leF.lnE -textvariable npf(testLength) -width 10
   pack  $lF.leF.lnL $lF.leF.lnE -padx 2 -pady 2
   frame $lF.lnF -bd 2 -relief groove
   pack  $lF.lnF -pady 2 -side left -padx 2 -expand true
   radiobutton $lF.lnF.secR -text "seconds" -variable npf(sXb) -value 1
   radiobutton $lF.lnF.bytesR -text "bytes" -variable npf(sXb) -value {-1}
   pack $lF.lnF.secR $lF.lnF.bytesR -anchor w
   #test type
   set tF [frame $u4tF.paramF.standardF.testF -bd 2 -relief groove]
   pack  $tF -padx 2 -pady 2 -fill x -ipady 2
   frame $tF.ttcpF
   pack  $tF.ttcpF -side left -padx 2 -anchor c
   label $tF.ttcpF.testL -text "Test Type"
   pack  $tF.ttcpF.testL -padx 20 -anchor n
   frame $tF.typeF -bd 2 -relief groove
   pack  $tF.typeF -side right -padx 30 -anchor c
   radiobutton $tF.typeF.tcpR -text TCP -variable npf(testType) \
     -value TCP_STREAM -command {
       pack $tF.ttcpF.testC -padx 2 -anchor s
     }
   radiobutton $tF.typeF.udpR -text UDP -variable npf(testType) \
     -value UDP_STREAM -command {
       pack forget $tF.ttcpF.testC
     }
   pack $tF.typeF.tcpR $tF.typeF.udpR -padx 2
   checkbutton $tF.ttcpF.testC -text NODELAY -variable npf(tcpNodelay)
   pack $tF.ttcpF.testC -padx 2 -anchor s
   if ![string compare "UDP_STREAM"  $npf(testType)] {
      pack forget $tF.ttcpF.testC
   }

   ##########################################
   # LISTBOX Custom parameters
   #########################################
   frame $cF.right  -bd 2 -relief groove
   pack  $cF.right  -pady 3 -padx 3 -fill both -side top  -anchor n
   frame $cF.right.flows
   pack  $cF.right.flows -padx 3 -pady 3 -fill both
   label $cF.right.flows.l -text "Custom Parameters"
   pack  $cF.right.flows.l -padx 3 -anchor c
   set reslb [listbox $cF.right.flows.lb -xscrollcommand "$cF.right.flows.sx set" \
     -yscrollcommand "$cF.right.flows.sy set" -width 2 -height 10 \
     -selectmode multiple]
   scrollbar $cF.right.flows.sx -orient horizontal -command \
     "$cF.right.flows.lb xview"
   scrollbar $cF.right.flows.sy -orient vertical -command \
     "$cF.right.flows.lb yview"

   frame $cF.right.b
   pack  $cF.right.b -padx 3 -pady 3 -expand true
   button $cF.right.b.b1 -text "Add Parameter" -command AddParameter \
     -bd 2 -relief groove
   button $cF.right.b.b2 -text "Edit Parameter" \
     -command EditSelectedParameter -bd 2 -relief groove
   button $cF.right.b.b3 -text "Delete Parameter" \
     -command DeleteSelectedParameter -bd 2 -relief groove
   pack $cF.right.b.b1 $cF.right.b.b2 $cF.right.b.b3  -padx 2 -side left
   pack $cF.right.flows.sx -side bottom -fill x
   pack $cF.right.flows.sy -side right -fill y
   pack $cF.right.flows.lb -fill both -expand true
   set y $cF.right.flows.lb

   for {set i 1} {$i<=$customEnd} {incr i} {
      $y insert end "$customparams(name,$i) : $customparams(value,$i)"
   }
   $y see end

   ##########################################
   # File settings
   #########################################
   #netperf:
   frame $cF.nF
   pack $cF.nF -pady 2 -fill x
   label $cF.nF.nL -text "(SRC)Netperf Path"
   entry $cF.nF.nE -textvariable npf(netperfPath) -width 27
   pack $cF.nF.nL -padx 2 -side left
   pack $cF.nF.nE -padx 2 -side right -fill x

   #netSERVER
   frame $cF.nsF
   pack $cF.nsF -pady 2 -fill x
   label $cF.nsF.nL -text "(DST)Netserver Path"
   entry $cF.nsF.nE -textvariable npf(netserverpath) -width 27
   pack $cF.nsF.nL -padx 2 -side left
   pack $cF.nsF.nE -padx 2 -side right -fill x

   #results
   frame $cF.rezF
   pack $cF.rezF -pady 2 -fill both
   label $cF.rezF.rezL -text "(LOC)Save Results File"
   entry $cF.rezF.rezE -textvariable npf(resultsFileNpf) -width 27
   pack $cF.rezF.rezL -padx 2 -side left
   pack $cF.rezF.rezE -padx 2 -side right -fill x

   ##################################################
   # CONSOLE STDOUT listbox + buttons
   ##################################################
   frame $u4tF.consoleF.bF -bd 2 -relief groove
   pack $u4tF.consoleF.bF -side left -padx 2 -pady 2 -fill y
   button $u4tF.consoleF.bF.runB -text "Run Test" \
     -command RunTest -width 14
   button $u4tF.consoleF.bF.resultsB -text "Graphic Results" \
     -command {NetGRAPH npf} -width 14
   button $u4tF.consoleF.bF.quitB -text "Quit" \
     -command Quit -width 14
   pack $u4tF.consoleF.bF.runB $u4tF.consoleF.bF.resultsB \
     $u4tF.consoleF.bF.quitB -padx 2 -pady 2 -anchor c -expand true
   set z4 [listbox $u4tF.consoleF.cLB -height 7 -font normal]
   set csy [scrollbar $u4tF.consoleF.sY -orient vertical \
     -command "$z4 yview"]
   pack $csy -fill y -side right
   $z4 config -yscrollcommand "$csy set"
   pack $z4 -fill both -side left -expand true
}

# ------------------------------------------------------------------
#           procedure - ADDPARAMETER
# ------------------------------------------------------------------
proc AddParameter {} \
{
	global customparams done customEnd y paramName paramValue
	
	###init data
	set paramName {}
	set paramValue {}
	
	toplevel .dialog
	wm title .dialog "Add Parameter"
	wm resizable .dialog 0 0
	wm protocol .dialog WM_DELETE_WINDOW {;#do nothing}
	frame .dialog.nameF
	frame .dialog.valueF
	frame .dialog.buttonsF
	
	pack .dialog.nameF .dialog.valueF .dialog.buttonsF -pady 3
	
	#name
	label .dialog.nameF.nameL -text "Name"
	entry .dialog.nameF.nameE -textvariable paramName  -width 45
	pack .dialog.nameF.nameL -side left -padx 2
	pack .dialog.nameF.nameE -side right -padx 2
	
	#value
	label .dialog.valueF.valueL -text "Value"
	entry .dialog.valueF.valueE -textvariable paramValue  -width 45
	pack .dialog.valueF.valueL -side left -padx 2
	pack .dialog.valueF.valueE -side right -padx 2
	
	#buttons
	button .dialog.buttonsF.okB -text OK -command {set done ok}
	button .dialog.buttonsF.cancelB -text Cancel -command {set done cancel}
	pack .dialog.buttonsF.okB .dialog.buttonsF.cancelB \
	-side left -anchor c -expand true
	
	#tcl part
	set done not_yet
	grab .dialog
	tkwait variable done
	grab release .dialog
	destroy .dialog
	
	#OK or Cancel pressed, at this point
	if {![string compare $done ok]} \
	{
		if {![string compare {} [string trim $paramName]]} \
		{
			#nothing eligible was specified
			return
		}
		incr customEnd
		set customparams(name,$customEnd) $paramName
		set customparams(value,$customEnd) $paramValue
	
		#update listbox data:
		$y insert end "$paramName : $paramValue"
		$y see end
	}
	#else, cancel was pressed
}


# ------------------------------------------------------------------
#          procedure - EDITSELECTEDPARAMETER
# ------------------------------------------------------------------
proc EditSelectedParameter {} {
	#modify values for an existent name
	global customparams done y paramValue exLine
	set exLine [$y curselection]
	if {![string compare $exLine {}]} \
	{
		return ;
		#nothing selected
	}
	#else:
	set paramValue {}
	incr exLine
	toplevel .dialog
	wm title .dialog "Edit Parameter"
	wm resizable .dialog 0 0
	wm protocol .dialog WM_DELETE_WINDOW {;#do nothing}
	label .dialog.titleL -text "Insert New Value"
	frame .dialog.paramF
	frame .dialog.buttonsF
	pack .dialog.titleL .dialog.paramF .dialog.buttonsF -pady 3
	label .dialog.paramF.numeL -text "$customparams(name,$exLine)"
	entry .dialog.paramF.valueE -textvariable paramValue  -width 45
	pack .dialog.paramF.numeL -side left -padx 2
	pack .dialog.paramF.valueE -side right -padx 2
	button .dialog.buttonsF.okB -text OK -command {set done ok}
	button .dialog.buttonsF.cancelB -text Cancel -command {set done cancel}
	pack .dialog.buttonsF.okB .dialog.buttonsF.cancelB -side left \
	  -anchor c -padx 5
	set done not_yet
	grab .dialog
	tkwait variable done
	grab release .dialog
	destroy .dialog
	if {![string compare $done ok]} {
		set customparams(value,$exLine) $paramValue
		set nr [expr $exLine-1]
		$y delete $nr
		$y insert $nr "$customparams(name,$exLine) : $customparams(value,$exLine)"
	}
}

# ------------------------------------------------------------------
#          DELETESELECTEDPARAMETER
# ------------------------------------------------------------------
proc DeleteSelectedParameter {} \
{
	global y customparams customEnd exLine
	
	set exLine [$y curselection]
	if ![string compare $exLine {}] {
		return
		#nothing selected
	}
	$y delete $exLine
	incr exLine
	while {$exLine < $customEnd} {
		set customparams(name,$exLine) $customparams(name,[expr $exLine+1])
		set customparams(value,$exLine) $customparams(value,[expr $exLine+1])
		incr exLine
	}
	unset customparams(name,$customEnd)
	unset customparams(value,$customEnd)
	incr customEnd -1
}

####################################################################
# ------------------------------------------------------------------
#          procedure - RUNTEST
# ------------------------------------------------------------------
####################################################################
proc RunTest {} \
{
   #globals:
   global u4tF errorInfo
   global sndF rcvF tF lF cF y z4
   global npf ;#array with all netperf related parameters
   global customparams customEnd
   #global testLength

   #from page 1:
   global sender receiver host scenarioDir
   global input4
   global input42
   global npfCommand
   global stopnetperfCMD
   global stopserverCMD
   global ready4
   global remoteHost senderHost  
   global _sshCMD


   #clear list
   $z4 delete 0 end
   catch {unset z4List}


   ###################################################################
   ###################################################################
   set localReceiver $receiver(local,ipv4)
   if $localReceiver \
   {
      set remoteHost $host(address,ipv4,unicast)
      set serverCMD  "$npf(netserverpath)"
      set stopserverCMD "killall netserver -STOP"
   } else {
      set remoteHost   $receiver(address,ipv4,unicast)
      set receiverHost $receiver(address,ipv4,unicast)
      set serverCMD     "$_sshCMD -l $receiver(login,ipv4)  $receiverHost $npf(netserverpath) "

      #set serverCMD     "$_sshCMD -l $receiver(login,ipv4)  10.255.10.1 $npf(netserverpath) "

      set stopserverCMD "$_sshCMD -l $receiver(login,ipv4)  $receiverHost killall netserver -STOP"
   }
   set localSender $sender(local,ipv4,unicast)
   if $localSender \
   {
      set senderHost $host(address,ipv4,unicast)
      set npfCommand [list $npf(netperfPath)]
      set stopnetperfCMD "killall netperf -STOP"
   } else {
      set senderHost $sender(address,ipv4,unicast)
      set npfCommand "$_sshCMD -l $sender(login,ipv4,unicast) $senderHost $npf(netperfPath)"

      #set npfCommand "$_sshCMD -l $sender(login,ipv4,unicast) 10.255.10.2 $npf(netperfPath)"

      set stopnetperfCMD "$_sshCMD -l $sender(login,ipv4,unicast) $senderHost killall netperf -STOP"
   }
   ###################################################################
   ###################################################################
 
   ####################
   #for the use of IPv4
   ####################
   #lappend serverCMD " -4 "
   lappend npfCommand "-t $npf(testType)"
   lappend npfCommand "-H $remoteHost"
   ####################

   #PORT NUMBER for NETSERVER
   if $npf(portNumberBool) \
   {
       if [string compare {} [string trim $npf(portNumber)]] \
       {
          #the user wrote an integer value:
          lappend  serverCMD " -p $npf(portNumber) "
       }
   } else {   #default port of NETSERVER 
      lappend  serverCMD " -p 12865"
   }
   ###################################################################
   ###################################################################

   #test length:
   if [string compare {} [string trim $npf(testLength)]] \
   {
       if {$npf(sXb) == 1} \
       {
          lappend npfCommand "-l $npf(testLength)"

       } else {
          lappend npfCommand "-l -$npf(testLength)"
       }
   }

   #port number
   if $npf(portNumberBool) \
   {
       if [string compare {} [string trim $npf(portNumber)]] \
       {
          #the user wrote an integer value:
          lappend npfCommand "-p $npf(portNumber)"
       }
   }
   #local switches:
   lappend npfCommand "--"
   #send socket size
   if $npf(sendSocketSizeBool) \
   {
       if [string compare {} [string trim $npf(sendSocketSize)]] \
       {
          lappend npfCommand "-s $npf(sendSocketSize)"
       }
   }

   #recv socket size
   if $npf(recvSocketSizeBool) \
   {
       if [string compare {} [string trim $npf(recvSocketSize)]] \
       {
          lappend npfCommand "-S $npf(recvSocketSize)"
       }
   }

   #send message size
   if $npf(sendMessageSizeBool) \
   {
       if [string compare {} [string trim $npf(sendMessageSize)]] \
       {
          lappend npfCommand "-m $npf(sendMessageSize)"
       }
   }

   #recv message size
   if $npf(recvMessageSizeBool) \
   {
       if [string compare {} [string trim $npf(recvMessageSize)]] \
       {
          lappend npfCommand "-M $npf(recvMessageSize)"
       }
   }

   #tcp_nodelay:
   if ![string compare $npf(testType) TCP_STREAM] \
   {
       if $npf(tcpNodelay) \
       {
          lappend npfCommand "-D"
       }
   }

   ####################################################
   # test COMAND LINE for NETPERF
   ####################################################
   #tk_messageBox -message "NETPERF command:\n $npfCommand"
   #tk_messageBox -message "Netserver command:\n $serverCMD"
   ####################################################

   if $npf(portNumberBool) \
   { 
     set line "Netserver loading on host $remoteHost at port $npf(portNumber) "
   } else  {
     set line "Netserver loading on host $remoteHost at port default"
   }
   $z4 insert end $line

   #check:
   #launch netserver:
   if [catch {open "|[join $serverCMD]" r+ } input42] \
   {
      tk_messageBox -message "A: $input42"
      return  
   }

   set ready4 "0"
   #fconfigure $input42 -blocking false
   fileevent  $input42 readable {
     if [eof $input42] \
     {
       catch {close $input42} val2
       #$z4 insert end " - INPUT42 may be closed"
       #$z4 see  end 
       if [string compare {} $val2] \
       {
	   tk_messageBox -message "$val2"
           $u4tF.consoleF.bF.runB config -text "Run Test" -command RunTest
           return
       }
     } else \
     {
       #waiting for a reply from Netserver
       gets $input42 line
       if { $ready4 == "0" } \
       {
         $z4 insert end $line
         $z4 insert end " - Netserver ready"
         $z4 insert end " - Netperf running"
         RUNnetperf 
         set ready4 "1"
       }
     }
   }
}





proc RUNnetperf  {} \
{
   global u4tF errorInfo
   global sndF rcvF tF lF cF y z4
   global npf ;#array with all netperf related parameters
   global customparams customEnd
   #global testLength

   #from page 1:
   global sender receiver host scenarioDir
   global input4
   global input42
   global npfCommand
   global stopnetperfCMD
   global stopserverCMD


   #check:
   #launch netperf:
   if [catch {open "|[join $npfCommand]" r+ } input4] \
   {
      #something is not ok for netperf or rexec
      tk_messageBox -message "B: $input4"
   } else {
      #ok
      fileevent $input4 readable Log
      $u4tF.consoleF.bF.runB config -text "Stop" -command KillNpf
   }
}



####################################################################
# ------------------------------------------------------------------
#           procedure - LOG
# ------------------------------------------------------------------
####################################################################
proc Log {} \
{
   global z4 input4 u4tF
   global netlist

   catch {unset netlist}
   set neltlist ""

   if [eof $input4] \
   {
       catch {close $input4} val
       #$z4 insert end " - INPUT4 may be closed"
       #$z4 see  end 
       if [string compare {} $val] \
       {
           #no se puede ejecutar NETPERF 
	   tk_messageBox -message "$val"
           $u4tF.consoleF.bF.runB config -text "Run Test" -command RunTest
           return
       }
       StopServer
       $z4 insert end " - Saving data"
       SaveData
       catch {unset outList}
       #$z4 see 0
   } else \
   {
       gets $input4 line
       lappend netlist $line
       $z4 insert end "$line"
   }
}


####################################################################
# ------------------------------------------------------------------
#          KILLNPF
# ------------------------------------------------------------------
####################################################################
proc KillNpf {} \
{
   global u4tF input4
   global stopnetperfCMD
   global z4

   $z4 insert end "                    "
   $z4 insert end " - Test stopped by user"
   $z4 insert end " - Netperf stopped...... "
   $z4 see end
   update idletasks

   $u4tF.consoleF.bF.runB config -text "Run Test" -command RunTest
   if [catch {open "|$stopnetperfCMD" r+ } errx] {
      tk_messageBox -message "1: $errx"
      update idletasks
      return
   }
   catch {close $input4}
   StopServer
}


###################################################################
#------------------------------------------------------------------
#                       STOP NETSERVER
#------------------------------------------------------------------
###################################################################
proc StopServer {} {
   global stopserverCMD
   global u4tF input42
   global z4  

   set line " - Netserver stopped....."
   $z4 insert end $line
   $z4 see end
   update idletasks
   if [catch {open "|$stopserverCMD" r+ } err2] {
      tk_messageBox -message "2: $err2"
      update idletasks
      return
   }
   catch {close $input42}
}







####################################################################
# ------------------------------------------------------------------
#                 SAVEDATA
# ------------------------------------------------------------------
####################################################################
proc SaveData {} \
{
   global u4tF
   global env
   global npf scenarioDir customparams customEnd
   global y z4
   global li5 li6
   global remoteHost senderHost  

   ###read netperf output to decide what follows

   set max [$z4 index end]
   incr max -1
   if !$max \
   {
      #nothing in the listbox
      return
      tk_messageBox -message "RET 1"
   }
   #else:
   set index4 "4"
   set line [ lindex [ split [ $z4 get $index4 ]] 0 ]
   if [string compare TCP $line] \
   {
       if [string compare UDP $line] \
       {
          #errors, no data
          tk_messageBox -message "RET 2"
          return
       }
   }
   incr index4
   incr max -1	;#verify that second line exists
   if !$max \
   {
      tk_messageBox -message "RET 3"
      #nothing in on the second line
      return
   }
   #else:
   set line [ lindex [ split [ $z4 get $index4 ]] 0 ]
   if [string compare Recv $line] \
   {
       if [string compare Socket $line] \
       {
       tk_messageBox -message "line2: $line"
          #errors, no data
          tk_messageBox -message "RET 4"
          return
       }
   }
   #the "data" dir:
   set path2 data

   #scenario specific dir:
   set path3 [string trim [string trim $scenarioDir(ipv4,unicast)] {/}]

   #file name (maybe it contains other directories, like : /wfq/test.npf)
   set path4 [string trim [string trim $npf(resultsFileNpf)] {/}]

   if [string compare {} $path3] \
   {
      set fPath "$path2/$path3/$path4"
   } else {
      #no scenario directory specified
      set fPath "$path2/$path4"
   }
   #see if the user specified a file name
   #if not, save to "default.npf"
   if ![string compare {} $path4] \
   {
      append fPath default.npf
      #update path
      set npf(resultsFileNpf) default.npf
   }
   #append file extension (.npf), if needed
   #append file extension (.npf), if needed

   if [string compare {.npf} [file extension $fPath]] \
   {
      append fPath .npf
   }
   #find the parent directory path for the file,
   #to create it
   set dPath [file dirname $fPath]
   #now try to create it
   if [catch {file mkdir $dPath} dErr] \
   {
       tk_messageBox -message "Failed to create\nspecified directory\nstructure"
       return
   }


   #################################
   # M U L T I F L O W     F I L E S 
   #################################
   #Exists?
   if [file exists $fPath] \
   {

      #Append ?
      set answer [tk_messageBox -message "File exists!\nAppend ?" \
      -type yesno -icon question]
      if [string compare yes $answer] \
      {
            #no Append
            #Overwrite ?
            set answer [tk_messageBox -message "Overwrite?" \
            -type yesno -icon question]
            if [string compare yes $answer] {

                  #no Overwrite
                  $u4tF.consoleF.bF.runB config -text "Save Data" -command SaveData
                  tk_messageBox -message "Change result file name and press SaveData button" 
                  update idletasks
                  return
            } else {

                  #yes Overwrite
                  set fID [open $fPath w]
            }

      } else {
            #yes Append
            set fID [open $fPath a]
      }
   } else {
            set fID [open $fPath w]
   }

   #write data to file:
   #obtain the line 5 and 6 from listbox (netperf output)
   catch {unset li5}
   catch {unset li6}
   set l [split [$z4 get 9]]
   foreach i $l {
      if [string compare $i {}] \
      {
          if [string compare $i "\x0A"] \
          {
             lappend li5 $i
          }
      }
   }
   set l [split [$z4 get 10]]
   foreach i $l \
   {
      if [string compare $i {}] \
      {
          if [string compare $i "\x0A"] \
          {
             lappend li6 $i
          }
      }
   }
   ###############################
   # Start to SAVE the FILE
   ###############################
   puts $fID " "
   puts $fID "Netperf measure"
   puts $fID "Flow name: $npf(title)"
   puts $fID " "
   puts $fID "Test Type  $npf(testType)"
   puts $fID "Source Address:  $remoteHost"
   puts $fID "Destination Address: $senderHost "
   if ![string compare $npf(testType) TCP_STREAM] \
   {
      ####################################################################
      #tk_messageBox -message "lineex6: \n $li6"
      ####################################################################
      #tcp test
      puts $fID "-Message size (bytes): [lindex $li6 2]"
#      puts $fID "-IP Message size (bytes): [expr [lindex $li6 2] +48]"
      puts $fID "-Throughput (Mbps): [lindex $li6 4]"
      puts $fID "-Test duration (sec): [lindex $li6 3]"
      puts $fID "-Send socket size (bytes): [lindex $li6 1]"
      puts $fID "-Recv socket size (bytes): [lindex $li6 0]"
      puts $fID "TCP_NODELAY   $npf(tcpNodelay)"
      if {$npf(sXb) == -1}  { puts $fID "-Test length (bytes): $npf(testLength)" }
   } else {
      ####################################################################
      #tk_messageBox -message "lineex6: \n $li6"
      #tk_messageBox -message "lineex5: \n $li5"
      ####################################################################
      #udp test
      puts $fID "-Message size (bytes): [lindex $li5 1]"
#      puts $fID "-IP Message size (bytes): [expr [lindex $li5 1] +28]"
      puts $fID "-Throughput (Mbps): [lindex $li6 3]"
      puts $fID "-Test duration (sec): [lindex $li6 1]"
      puts $fID "-Send socket size (bytes): [lindex $li5 0]"
      puts $fID "-Recv socket size (bytes): [lindex $li6 0]"
      puts $fID "-Send throughput (bytes): [lindex $li5 5]"
      puts $fID "-Send OK messages: [lindex $li5 3]"
      puts $fID "-Recv OK messages: [lindex $li6 2]"
      puts $fID "-Failed send calls: [lindex $li5 4]"
   }
   ##Recv Message Size, when provided:
   if $npf(recvMessageSizeBool) \
   {
       if [string compare {} [string trim $npf(recvMessageSize)]] \
       {
          puts $fID "-Recv message size (bytes): $npf(recvMessageSize)"
       }
   }
   set first 1
   for {set i 1} {$i<=$customEnd} {incr i} \
   {
     if { $first == 1 } {  puts $fID "custom parameters:" }
     puts $fID "-$customparams(name,$i): $customparams(value,$i)"
     set first 0 
   }

   #close file
   catch {close $fID}
   ##final message here
   $z4 insert end " - Data Saved Successfully : $fPath"
   $z4 insert end " - Netperf Test complete"
   $z4 see end
   update idletasks
   $u4tF.consoleF.bF.runB config -text "Run Test" -command RunTest



#   if [catch {open "ouput_listbox.txt" w} xID] {
#     return
#   }
#
#   set my [$z4 get 0 end]
#   foreach line $my {
#      puts $xID $line
#   }
#   catch {close $xID}

}
