###############################################
# Copyright 2002, 2003 Ren Serral,           #
#                      Roberto Borgione       #
# thrum6.tcl - Unicast Throughput IPv6        #
#       v2.0 (04-2002)                        #
#       v2.01(02-2003)                        #
###############################################

#   This file is part of NetMeter.
#
#   NetMeter is free software; you can redistribute it and/or modify
#   it under the terms of the GNU General Public License as published by
#   the Free Software Foundation; either version 2 of the License, or
#   (at your option) any later version.
#
#   NetMeter is distributed in the hope that it will be useful,
#   but WITHOUT ANY WARRANTY; without even the implied warranty of
#   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#   GNU General Public License for more details.
#
#   You should have received a copy of the GNU General Public License
#   along with NetMeter; if not, write to the Free Software
#   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

###################################################################
# ------------------------------------------------------------------
#	           Netperf Multicast IPv6
# ------------------------------------------------------------------
####################################################################
proc Throughput:Tm6 {}\
{
   global m6tF
   global netserverpath
   global sndF6 rcvF6 tF6 lF6 cF6  z
   global npf6
   global reslb
   global customparams6 customEnd6 c6lb


   frame $m6tF.paramF
   frame $m6tF.consoleF
   pack  $m6tF.paramF $m6tF.consoleF -fill x
   frame $m6tF.paramF.standardF -bd 2 -relief groove
   set   cF6 [frame $m6tF.paramF.customF -bd 2 -relief groove]
   pack  $m6tF.paramF.standardF $m6tF.paramF.customF -side left \
         -fill both -padx 2 -pady 2 -expand true

   label $m6tF.paramF.standardF.titleL -text "IPv6 - Netperf Options" -relief raised
   pack  $m6tF.paramF.standardF.titleL -anchor c  -fill x -padx 3 -pady 3

   frame $m6tF.paramF.standardF.title
   pack  $m6tF.paramF.standardF.title -pady 2 -fill x
   label $m6tF.paramF.standardF.title.l -text "Title measure"
   pack  $m6tF.paramF.standardF.title.l -side left -padx 3
   entry $m6tF.paramF.standardF.title.e -textvariable npf6(title) -width 25
   pack  $m6tF.paramF.standardF.title.e -side right -padx 3

   frame $m6tF.paramF.standardF.dF
   pack  $m6tF.paramF.standardF.dF -fill x -pady 2
   set   sndF6 [frame $m6tF.paramF.standardF.dF.sendF -bd 2 -relief groove]
   set   rcvF6 [frame $m6tF.paramF.standardF.dF.recvF -bd 2 -relief groove]
   pack  $sndF6 $rcvF6 -padx 2 -pady 2 -fill x -anchor n
   label $sndF6.senderL -text Sender
   pack  $sndF6.senderL -pady 2 -anchor c


   ##########################################
   # Check-Button parameters Netperf
   #########################################

   #(send) message size option:
   frame $sndF6.smessageF
   pack  $sndF6.smessageF -pady 2 -fill x
   entry $sndF6.smessageF.smE -textvariable npf6(sendMessageSize)  \
         -state disabled -fg gray -width 10
   checkbutton $sndF6.smessageF.smC -text "Send Message Size" \
         -variable npf6(sendMessageSizeBool) -command \
   {
            if $npf6(sendMessageSizeBool) \
	    {
              $sndF6.smessageF.smE configure -state normal -fg black
	    } else {
              $sndF6.smessageF.smE configure -state disabled -fg gray
            }
   }
   #update state with the value of the Bool
   if $npf6(sendMessageSizeBool) \
   {
       $sndF6.smessageF.smE configure -state normal -fg black
   } else {
       $sndF6.smessageF.smE configure -state disabled -fg gray
   }
   pack $sndF6.smessageF.smC -side left -fill x -padx 2
   pack $sndF6.smessageF.smE -side right -fill x -padx 2
   #send socket size option
   frame $sndF6.ssocketF
   pack  $sndF6.ssocketF -pady 2 -fill x
   entry $sndF6.ssocketF.ssE -textvariable npf6(sendSocketSize)  \
         -state disabled -fg gray -width 10
   checkbutton $sndF6.ssocketF.ssC -text "Send Socket Size" \
         -variable npf6(sendSocketSizeBool) -command \
   {
      if $npf6(sendSocketSizeBool) \
      {
          $sndF6.ssocketF.ssE configure -state normal -fg black
      } else {
          $sndF6.ssocketF.ssE configure  -state disabled -fg gray
      }
   };
   #update state with the value of the Bool
   if $npf6(sendSocketSizeBool) \
   {
       $sndF6.ssocketF.ssE configure -state normal -fg black
   } else {
       $sndF6.ssocketF.ssE configure  -state disabled -fg gray
   }
   pack $sndF6.ssocketF.ssC -side left -fill x -padx 2
   pack $sndF6.ssocketF.ssE -side right -fill x -padx 2
   #specify port:
   frame $sndF6.sportF
   pack  $sndF6.sportF -pady 2 -fill x
   entry $sndF6.sportF.spE -textvariable npf6(portNumber)  \
         -state disabled -fg gray -width 10
   checkbutton $sndF6.sportF.spC -text "Port Number" \
         -variable npf6(portNumberBool) -command \
   {
      if $npf6(portNumberBool) \
      {
          $sndF6.sportF.spE configure -state normal -fg black
      } else {
          $sndF6.sportF.spE configure  -state disabled -fg gray
      }
   };
   #update state with the value of the Bool
   if $npf6(portNumberBool) \
   {
       $sndF6.sportF.spE configure -state normal -fg black
   } else {
       $sndF6.sportF.spE configure  -state disabled -fg gray
   }
   pack $sndF6.sportF.spC -side left -fill x -padx 2
   pack $sndF6.sportF.spE -side right -fill x -padx 2
   ##receiver related widgets
   #section title
   label $rcvF6.recvL -text Receiver
   pack $rcvF6.recvL -pady 2 -anchor c
   #(receive) message size option:
   frame $rcvF6.rmessageF
   pack  $rcvF6.rmessageF -pady 2 -fill x
   entry $rcvF6.rmessageF.rmE -textvariable npf6(recvMessageSize)  \
         -state disabled -fg gray -width 10
   checkbutton $rcvF6.rmessageF.rmC -text "Recv Message Size" \
         -variable npf6(recvMessageSizeBool) -command \
   {
      if $npf6(recvMessageSizeBool) \
      {
          $rcvF6.rmessageF.rmE configure -state normal -fg black
      } else {
          $rcvF6.rmessageF.rmE configure  -state disabled -fg gray
      }
   };
   #update state with the value of the Bool
   if $npf6(recvMessageSizeBool) \
   {
       $rcvF6.rmessageF.rmE configure -state normal -fg black
   } else {
       $rcvF6.rmessageF.rmE configure  -state disabled -fg gray
   }
   pack $rcvF6.rmessageF.rmC -side left -fill x -padx 2
   pack $rcvF6.rmessageF.rmE -side right -fill x -padx 2
   #receive socket size option
   frame $rcvF6.rsocketF
   pack $rcvF6.rsocketF -pady 2 -fill x
   entry $rcvF6.rsocketF.rsE -textvariable npf6(recvSocketSize)  \
   -state disabled -fg gray -width 10
   checkbutton $rcvF6.rsocketF.rsC -text "Recv Socket Size" \
   -variable npf6(recvSocketSizeBool) -command \
   {
      if $npf6(recvSocketSizeBool) \
      {
          $rcvF6.rsocketF.rsE configure -state normal -fg black
      } else {
          $rcvF6.rsocketF.rsE configure  -state disabled -fg gray
      }
   };
   #update state with the value of the Bool
   if $npf6(recvSocketSizeBool) \
   {
       $rcvF6.rsocketF.rsE configure -state normal -fg black
   } else {
       $rcvF6.rsocketF.rsE configure  -state disabled -fg gray
   }
   pack $rcvF6.rsocketF.rsC -side left -fill x -padx 2
   pack $rcvF6.rsocketF.rsE -side right -fill x -padx 2

   ##test type, tcp_nodelay and test length widgets test length (duration)
   set   lF6 [frame $m6tF.paramF.standardF.lengthF -bd 2 -relief groove]
   pack  $lF6 -padx 2 -pady 2 -fill x
   frame $lF6.leF
   pack  $lF6.leF -pady 2 -side left -expand true
   label $lF6.leF.lnL -text "Test Duration"
   entry $lF6.leF.lnE -textvariable npf6(testLength) -width 10
   pack  $lF6.leF.lnL $lF6.leF.lnE -padx 2 -pady 2
   frame $lF6.lnF -bd 2 -relief groove
   pack  $lF6.lnF -pady 2 -side left -padx 2 -expand true
   radiobutton $lF6.lnF.secR -text "seconds" -variable npf6(sXb) \
         -value 1
   radiobutton $lF6.lnF.bytesR -text "bytes" -variable npf6(sXb) \
         -value {-1}
   pack $lF6.lnF.secR $lF6.lnF.bytesR -anchor w
   #test type
   set tF6 [frame $m6tF.paramF.standardF.testF -bd 2 -relief groove]
   pack  $tF6 -padx 2 -pady 2 -fill x -ipady 2
   frame $tF6.ttcpF
   pack  $tF6.ttcpF -side left -padx 2 -anchor c
   label $tF6.ttcpF.testL -text "Test Type"
   pack  $tF6.ttcpF.testL -padx 20 -anchor n
   frame $tF6.typeF -bd 2 -relief groove
   pack  $tF6.typeF -side right -padx 30 -anchor c
   radiobutton $tF6.typeF.tcpR -text TCP -variable npf6(testType) \
         -value TCPIPV6_STREAM -command \
   {
      pack $tF6.ttcpF.testC -padx 2 -anchor s
   }
   radiobutton $tF6.typeF.udpR -text UDP -variable npf6(testType) \
         -value UDPIPV6_STREAM -command \
   {
      pack forget $tF6.ttcpF.testC
   }
   pack $tF6.typeF.tcpR $tF6.typeF.udpR -padx 2
   checkbutton $tF6.ttcpF.testC -text NODELAY -variable npf6(tcpNodelay)
   pack $tF6.ttcpF.testC -padx 2 -anchor s
   if ![string compare "UDPIPV6_STREAM"  $npf6(testType)] {
      pack forget $tF6.ttcpF.testC
   }

   #########################################
   # LISTBOX Custom parameters
   #########################################
   frame $cF6.right  -bd 2 -relief groove
   pack  $cF6.right  -pady 3 -padx 3 -fill both -side top  -anchor n
   frame $cF6.right.flows
   pack  $cF6.right.flows -padx 3 -pady 3 -fill both
   label $cF6.right.flows.l -text "Custom Parameters"
   pack  $cF6.right.flows.l -padx 3 -anchor c
   set   reslb [listbox $cF6.right.flows.lb -xscrollcommand "$cF6.right.flows.sx set" \
         -yscrollcommand "$cF6.right.flows.sy set" -width 2 -height 10 \
         -selectmode multiple]
   scrollbar $cF6.right.flows.sx -orient horizontal -command \
         "$cF6.right.flows.lb xview"
   scrollbar $cF6.right.flows.sy -orient vertical -command \
         "$cF6.right.flows.lb yview"

   frame $cF6.right.b
   pack  $cF6.right.b -padx 3 -pady 3 -expand true
   button $cF6.right.b.b1 -text "Add Parameter" -command AddMParameter6 \
         -bd 2 -relief groove
   button $cF6.right.b.b2 -text "Edit Parameter" \
         -command EditMSelectedParameter6 -bd 2 -relief groove
   button $cF6.right.b.b3 -text "Delete Parameter" \
         -command DeleteMSelectedParameter6 -bd 2 -relief groove
   set c6lb $cF6.right.flows.lb

   for {set i 1} {$i<=$customEnd6} {incr i} \
   {
      $c6lb insert end "$customparams6(name,$i) : $customparams6(value,$i)"
   }
   $c6lb see end

   pack $cF6.right.b.b1 $cF6.right.b.b2 $cF6.right.b.b3 -padx 2 -side left
   pack $cF6.right.flows.sx -side bottom -fill x
   pack $cF6.right.flows.sy -side right -fill y
   pack $cF6.right.flows.lb -fill both -expand true

   ##########################################
   # File settings
   #########################################
   #netperf:
   frame $cF6.nF
   pack $cF6.nF -pady 2 -fill x
   label $cF6.nF.nL -text "(SRC)Netperf6 Path"
   entry $cF6.nF.nE -textvariable npf6(netperfPath) -width 27
   pack  $cF6.nF.nL -padx 2 -side left
   pack  $cF6.nF.nE -padx 2 -side right -fill x

   #netserver
   frame $cF6.nsF
   pack $cF6.nsF -pady 2 -fill x
   label $cF6.nsF.nL -text "(DST)Netserver6 Path"
   entry $cF6.nsF.nE -textvariable npf6(netserverpath) -width 27
   pack $cF6.nsF.nL -padx 2 -side left
   pack $cF6.nsF.nE -padx 2 -side right -fill x

   #results
   frame $cF6.rezF
   pack $cF6.rezF -pady 2 -fill both
   label $cF6.rezF.rezL -text "(LOC)Save Results File"
   entry $cF6.rezF.rezE -textvariable npf6(resultsFileNpf) -width 27
   pack $cF6.rezF.rezL -padx 2 -side left
   pack $cF6.rezF.rezE -padx 2 -side right -fill x

   ##################################################
   # CONSOLE STDOUT listbox + buttons
   ##################################################
   frame $m6tF.consoleF.bF -bd 2 -relief groove
   pack $m6tF.consoleF.bF -side left -padx 2 -pady 2 -fill y
   button $m6tF.consoleF.bF.runB -text "Run Test" \
   -command RunMTest6 -width 14
   button $m6tF.consoleF.bF.resultsB -text "Graphic Results" \
   -command {NetGRAPH npf} -width 14
   button $m6tF.consoleF.bF.quitB -text "Quit" \
   -command Quit -width 14
   pack $m6tF.consoleF.bF.runB $m6tF.consoleF.bF.resultsB \
   $m6tF.consoleF.bF.quitB -padx 2 -pady 2 -anchor c -expand true
   set z [listbox $m6tF.consoleF.cLB -height 7 -font normal]
   set csy [scrollbar $m6tF.consoleF.sY -orient vertical \
   -command "$z yview"]
   pack $csy -fill y -side right
   $z config -yscrollcommand "$csy set"
   pack $z -fill both -side left -expand true
}

# ------------------------------------------------------------------
#           procedure - ADD Multicast PARAMETER
# ------------------------------------------------------------------
proc AddMParameter6 {} \
{
	global customparams6 done customEnd6 c6lb paramName paramValue

	set paramName {}
	set paramValue {}

	toplevel .dialog
	wm title .dialog "Add Parameter"
	wm resizable .dialog 0 0
	wm protocol .dialog WM_DELETE_WINDOW {;#do nothing}
	frame .dialog.nameF
	frame .dialog.valueF
	frame .dialog.buttonsF
	pack .dialog.nameF .dialog.valueF .dialog.buttonsF -pady 3
	label .dialog.nameF.nameL -text "Name"
	entry .dialog.nameF.nameE -textvariable paramName  -width 45
	pack .dialog.nameF.nameL -side left -padx 2
	pack .dialog.nameF.nameE -side right -padx 2
	#value
	label .dialog.valueF.valueL -text "Value"
	entry .dialog.valueF.valueE -textvariable paramValue  -width 45
	pack .dialog.valueF.valueL -side left -padx 2
	pack .dialog.valueF.valueE -side right -padx 2
	#buttons
	button .dialog.buttonsF.okB -text OK -command {set done ok}
	button .dialog.buttonsF.cancelB -text Cancel -command {set done cancel}
	pack .dialog.buttonsF.okB .dialog.buttonsF.cancelB \
	-side left -anchor c -expand true
	#tcl part
	set done not_yet
	grab .dialog
	tkwait variable done
	grab release .dialog
	destroy .dialog
	#OK or Cancel pressed, at this point
	if {![string compare $done ok]} \
	{
		if {![string compare {} [string trim $paramName]]} \
		{
			#nothing eligible was specified
			return
		}
		incr customEnd6
		set customparams6(name,$customEnd6) $paramName
		set customparams6(value,$customEnd6) $paramValue
		#update listbox data:
		$c6lb insert end "$paramName : $paramValue"
		$c6lb see end
	}
}
   
# ------------------------------------------------------------------
#          procedure - EDIT Multicast SELECTEDPARAMETER
# ------------------------------------------------------------------
proc EditMSelectedParameter6 {} \
{
	global customparams6 done c6lb paramValue exLine
	global name value

	set exLine [$c6lb curselection]
	if {![string compare $exLine {}]} \
	{
		return ;
	}
	set paramValue {}
	incr exLine
	toplevel .dialog
	wm title .dialog "Edit Parameter"
	wm resizable .dialog 0 0
	wm protocol .dialog WM_DELETE_WINDOW {;#do nothing}
	label .dialog.titleL -text "Insert New Value"
	frame .dialog.paramF
	frame .dialog.buttonsF
	pack .dialog.titleL .dialog.paramF .dialog.buttonsF -pady 3
	label .dialog.paramF.numeL -text "$customparams6(name,$exLine)"
	entry .dialog.paramF.valueE -textvariable paramValue -width 45
	pack .dialog.paramF.numeL -side left -padx 2
	pack .dialog.paramF.valueE -side right -padx 2
	button .dialog.buttonsF.okB -text OK -command {set done ok}
	button .dialog.buttonsF.cancelB -text Cancel -command {set done cancel}
	pack .dialog.buttonsF.okB .dialog.buttonsF.cancelB -side left \
	-anchor c -padx 5
	set done not_yet
	grab .dialog
	tkwait variable done
	grab release .dialog
	destroy .dialog
	if {![string compare $done ok]} \
	{
		set customparams6(value,$exLine) $paramValue
		set nr [expr $exLine-1]
		$c6lb delete $nr
		$c6lb insert $nr "$customparams6(name,$exLine) : $customparams6(value,$exLine)"
	}
}

# ------------------------------------------------------------------
#          DELETE Multicast SELECTEDPARAMETER
# ------------------------------------------------------------------
proc DeleteMSelectedParameter6 {} \
{
	global c6lb customparams6 customEnd6 exLine

	set exLine [$c6lb curselection]
	if ![string compare $exLine {}] \
	{
		return
		#nothing selected
	}
	$c6lb delete $exLine
	incr exLine
	while {$exLine < $customEnd6} \
	{
		set customparams6(name,$exLine) $customparams6(name,[expr $exLine+1])
		set customparams6(value,$exLine) $customparams6(value,[expr $exLine+1])
		incr exLine
	}
	unset customparams6(name,$customEnd6)
	unset customparams6(value,$customEnd6)
	incr customEnd6 -1
}

####################################################################
# ------------------------------------------------------------------
#          procedure - RUN Multicast TEST ipv6
# ------------------------------------------------------------------
####################################################################
proc RunMTest6 {} \
{
   #globals:
   global m6tF errorInfo
   global sndF6 rcvF6 tF6 lF6 cF6 z
   global npf6;#array with all netperf related parameters
   global ready

   global remoteHost senderHost  
   global sender receiver host scenarioDir
   global input
   global input2
   global npfCommand
   global stopnetperfCMD
   global stopserverCMD
   global _sshCMD


   #clear list
   $z delete 0 end
   $z see end
   update idletasks
   catch {unset zList}

   ###################################################################
   ###################################################################
   set localReceiver $receiver(local,ipv4)
   if $localReceiver \
   {
      set remoteHost $host(address,ipv6,multicast)
      set serverCMD  "$npf6(netserverpath)"
      set stopserverCMD "kill netserver"
   } else {
      set remoteHost   $receiver(address,ipv6,multicast)
      set receiverHost $receiver(address,ipv4,multicast)
      set serverCMD     "$_sshCMD -l $receiver(login,ipv6)  $receiverHost $npf6(netserverpath) "
      set stopserverCMD "$_sshCMD -l $receiver(login,ipv6)  $receiverHost killall netserver -STOP"   
   }
   set localSender $sender(local,ipv4,multicast)
   if $localSender \
   {
      set senderHost $host(address,ipv6,multicast)
      set npfCommand [list $npf6(netperfPath)]
      set stopnetperfCMD "killall netperf"
   } else {
      #Only for IPv4 SSH compatibility 
      set senderHost $sender(address,ipv4,multicast)
      set npfCommand "$_sshCMD -l $sender(login,ipv6,multicast) $senderHost $npf6(netperfPath)"
      set stopnetperfCMD "$_sshCMD -l $sender(login,ipv6,multicast) $senderHost killall netperf"
      #really we need IPv6 @ 
      set senderHost $sender(address,ipv6,multicast)
   }
   ###################################################################
   ###################################################################
 
   ####################
   #for the use of IPv6
   ####################
   lappend serverCMD " -6 "
   lappend npfCommand "-t $npf6(testType)"
   lappend npfCommand "-H $remoteHost"
   ####################

   #PORT NUMBER for NETSERVER
   if $npf6(portNumberBool) \
   {
       if [string compare {} [string trim $npf6(portNumber)]] \
       {
          #the user wrote an integer value:
          lappend  serverCMD " -p $npf6(portNumber) "
       }
   } else {   #default port of NETSERVER 
      lappend  serverCMD " -p 12865"
   }

   #test length:
   if [string compare {} [string trim $npf6(testLength)]] \
   {
       if {$npf6(sXb) == 1} \
       {
          lappend npfCommand "-l $npf6(testLength)"

       } else {
          lappend npfCommand "-l -$npf6(testLength)"
       }
   }
   
	#port number
   if $npf6(portNumberBool) \
   {
       if [string compare {} [string trim $npf6(portNumber)]] \
       {
          #the user wrote an integer value:
          lappend npfCommand "-p $npf6(portNumber)"
       }
   }
   #local switches:
   lappend npfCommand "--"
   #send socket size
   if $npf6(sendSocketSizeBool) \
   {
       if [string compare {} [string trim $npf6(sendSocketSize)]] \
       {
          lappend npfCommand "-s $npf6(sendSocketSize)"
       }
   }

   #recv socket size
   if $npf6(recvSocketSizeBool) \
   {
       if [string compare {} [string trim $npf6(recvSocketSize)]] \
       {
          lappend npfCommand "-S $npf6(recvSocketSize)"
       }
   }

   #send message size
   if $npf6(sendMessageSizeBool) \
   {
       if [string compare {} [string trim $npf6(sendMessageSize)]] \
       {
          lappend npfCommand "-m $npf6(sendMessageSize)"
       }
   }

   #recv message size
   if $npf6(recvMessageSizeBool) \
   {
       if [string compare {} [string trim $npf6(recvMessageSize)]] \
       {
          lappend npfCommand "-M $npf6(recvMessageSize)"
       }
   }

   #tcp_nodelay:
   if ![string compare $npf6(testType) TCPIPV6_STREAM] \
   {
       if $npf6(tcpNodelay) \
       {
          lappend npfCommand "-D"
       }
   }

   ####################################################
   # test COMAND LINE for NETPERF6
   ####################################################
   #tk_messageBox -message "NETPERF command:\n $npfCommand"
   #tk_messageBox -message "NETserver command:\n $serverCMD"

   if $npf6(portNumberBool) \
   { 
     set line "Netserver loading on host $remoteHost at port $npf6(portNumber) "
   } else  {
     set line "Netserver loading on host $remoteHost at port default"
   }
   $z insert end $line
   $z see end
   update idletasks

   #check:
   #launch netserver:
   if [catch {open "|[join $serverCMD]" r+ } input2] \
   {
      tk_messageBox -message "A: $input2"
      return  
   }

   set ready "0"
   #fconfigure $input2 -blocking false
   fileevent  $input2 readable {
     if [eof $input2] \
     {
       catch {close $input2} val2
       if [string compare {} $val2] \
       {
	   tk_messageBox -message "$val2"
           $m6tF.consoleF.bF.runB config -text "Run Test" -command RunMTest6
           return
       }
     } else \
     {
       #waiting for a reply from Netserver
       gets $input2 line
       if { $ready == "0" } \
       {
         $z insert end $line
         $z insert end " - Netserver ready"
         $z insert end " - Netperf running"
         $z see end
         update idletasks
         RUNMnetperf6 
         set ready "1"
       }
     }
   }
};

proc RUNMnetperf6  {} \
{
   global m6tF errorInfo
   global sndF6 rcvF6 tF6 lF6 cF6 z
   global npf6;#array with all netperf related parameters
   #global testLength
   global ready

   #from page 1:
   global sender receiver host scenarioDir
   global input
   global input2
   global npfCommand

   #check:
   #launch netperf:

   if [catch {open "|[join $npfCommand]" r+ } input] \
   {
      #something is not ok for netperf or rexec
      tk_messageBox -message "B: $input"
   } else {
      #ok
      fileevent $input readable LogM6
      $m6tF.consoleF.bF.runB config -text "Stop" -command KillMNpf6
   }
}

####################################################################
# ------------------------------------------------------------------
#           procedure - LOG6
# ------------------------------------------------------------------
####################################################################
proc LogM6 {} \
{
   global z input m6tF
   global netlist

   catch {unset netlist}
   set neltlist ""

   if [eof $input] \
   {
       catch {close $input} val
       if [string compare {} $val] \
       {
           #no se puede ejecutar NETPERF 
	   tk_messageBox -message "$val"
           $m6tF.consoleF.bF.runB config -text "Run Test" -command RunMTest6
           return
       }
       StopMServer6
       $z insert end " - Saving data"
       $z see end
       update idletasks
       SaveData6
       catch {unset outList}
       #$z see 0
   } else \
   {
       gets $input line
       lappend netlist $line
       $z insert end "$line"
   }
}


####################################################################
# ------------------------------------------------------------------
#          KILL Multicast NPF6
# ------------------------------------------------------------------
####################################################################
proc KillMNpf6 {} \
{
   global m6tF input
   global stopnetperfCMD
   global z

   $z insert end "                    "
   $z insert end " - Test stopped by user"
   $z insert end " - Netperf stopped...... "
   $z see end
   update idletasks
      
   $m6tF.consoleF.bF.runB config -text "Run Test" -command RunMTest6
   if [catch {open "|$stopnetperfCMD" r+ } err] {
      tk_messageBox -message "1: $err"
      update idletasks
      return
   }
   catch {close $input}
   StopMServer6
}


###################################################################
#------------------------------------------------------------------
#                       STOP Multicast NETSERVER6
#------------------------------------------------------------------
###################################################################
proc StopMServer6 {} {
   global stopserverCMD
   global m6tF input2
   global z  

   set line " - Netserver stopped....."
   $z insert end $line
   $z see end
   update idletasks
   #tk_messageBox -message "stopserverCMD: $stopserverCMD"
   if [catch {open "|$stopserverCMD" r+ } err2] {
      tk_messageBox -message "2: $err2"
      update idletasks
      return
   }
   #catch {close $input2}
}

####################################################################
# ------------------------------------------------------------------
#                 SAVE Multicast DATA6
# ------------------------------------------------------------------
####################################################################
proc SaveMData6 {} \
{
   global env m6tF
   global npf6 scenarioDir
   global z
   global li5 li6
   global netlist
   global remoteHost senderHost  
   global customparams6 customEnd6 c6lb


   set max [$z index end]
   incr max -1
   if !$max \
   {
      #nothing in the listbox
      return
   }
   #else:
   set index "4"
   set line [ lindex [ split [ $z get $index ]] 0 ]
   ####################################################################
   #tk_messageBox -message "line: \n $line"
   ####################################################################
   if [string compare TCPIPV6 $line] \
   {
       if [string compare UDPIPV6 $line] \
       {
          #errors, no data
          return
       }
   }   else {
       set index "5"
   }
   #verify the second line, in a similar manner
   #it should contain as first word "Recv" or "Socket"
   #else -> some error was returned by netperf

   incr max -1	;#verify that second line exists
   if !$max \
   {
      #nothing in on the second line
      return
   }
   #else:
   set line [ lindex [ split [ $z get [incr index 1 ]]] 0 ]
   ####################################################################
   #tk_messageBox -message "line: \n $line"
   ####################################################################
   if [string compare Recv $line] \
   {
       if [string compare Socket $line] \
       {
          #errors, no data
          return
       }
   }
   set path2 data
   set path3 [string trim [string trim $scenarioDir(ipv6,multicast)] {/}]
   set path4 [string trim [string trim $npf6(resultsFileNpf)] {/}]
   ####################################################################
   #tk_messageBox -message "Path4 : $path4"
   #tk_messageBox -message "Path3 : $path3"
   ####################################################################

   if [string compare {} $path3] \
   {
      set fPath "$path2/$path3/$path4"
   } else {
      #no scenario directory specified
      set fPath "$path2/$path4"
   }
   #see if the user specified a file name
   #if not, save to "default.npf"
   if ![string compare {} $path4] \
   {
      append fPath default.npf
      #update path
  
      set npf6(resultsFileNpf) default.npf
   }

   #append file extension (.npf), if needed
   if [string compare {.npf} [file extension $fPath]] \
   {
      append fPath .npf
   }

   #########################################################################
   #tk_messageBox -message "dPath : $dPath "
   #tk_messageBox -message "fpath : $fPath "
   #tk_messageBox -message "getDrecLog : $getDrecLog "
   #########################################################################

   set dPath [file dirname $fPath]
   if [catch {file mkdir $dPath} dErr] \
   {
       tk_messageBox -message "Failed to create\nspecified directory\nstructure"
       return
   }

   #################################
   # M U L T I F L O W     F I L E S 
   #################################
   #File exists?
   if [file exists $fPath] \
   {

      #Append ?
      set answer [tk_messageBox -message "File exists!\nAppend ?" \
      -type yesno -icon question]
      if [string compare yes $answer] \
      {
            #no Append
            #Overwrite ?
            set answer [tk_messageBox -message "Overwrite?" \
            -type yesno -icon question]
            if [string compare yes $answer] {

                  #no Overwrite
                  $m6tF.consoleF.bF.runB config -text "Save Data" -command SaveMData6
                  tk_messageBox -message "Change result file name and press SaveData button" 
                  update idletasks
                  return
            } else {

                  #yes Overwrite
                  set fID [open $fPath w]
            }

      } else {
            #yes Append
            set fID [open $fPath a]
      }
   } else {
            set fID [open $fPath w]
   }

   #write data to file:
   #obtain the line 5 and 6 from listbox (netperf output)

   catch {unset li5}
   catch {unset li6}
   set l [split [$z get 9]]
   foreach i $l {
      if [string compare $i {}] \
      {
          if [string compare $i "\x0A"] \
          {
             lappend li5 $i
          }
      }
   }
   set l [split [$z get 10]]
   foreach i $l \
   {
      if [string compare $i {}] \
      {
          if [string compare $i "\x0A"] \
          {
             lappend li6 $i
          }
      }
   }

   ###############################
   # Start to SAVE the FILE
   ###############################
   puts $fID " "
   puts $fID "Netperf measure"
   puts $fID "Flow name: $npf6(title)"
   puts $fID " "
   puts $fID "Test Type  $npf6(testType)"
   puts $fID "Source Address:  $remoteHost"
   puts $fID "Destination Address: $senderHost "
   if ![string compare $npf6(testType) TCPIPV6_STREAM] \
   {
      ####################################################################
      #tk_messageBox -message "lineex6: \n $li6"
      ####################################################################
      #tcp test
      puts $fID "-Message size (bytes): [lindex $li6 2]"
#      puts $fID "-IP Message size (bytes): [expr [lindex $li6 2] +48]"
      puts $fID "-Throughput (Mbps): [lindex $li6 4]"
      puts $fID "-Test duration (sec): [lindex $li6 3]"
      puts $fID "-Send socket size (bytes): [lindex $li6 1]"
      puts $fID "-Recv socket size (bytes): [lindex $li6 0]"
      puts $fID "TCP_NODELAY   $npf6(tcpNodelay)"
      if {$npf6(sXb) == -1}  { puts $fID "-Test length (bytes): $npf6(testLength)" }
   } else {
      ####################################################################
      #tk_messageBox -message "lineex6: \n $li6"
      #tk_messageBox -message "lineex5: \n $li5"
      ####################################################################
      #udp test
      puts $fID "-Message size (bytes): [lindex $li5 1]"
#      puts $fID "-IP Message size (bytes): [expr [lindex $li5 1] +28]"
      puts $fID "-Throughput (Mbps): [lindex $li6 3]"
      puts $fID "-Test duration (sec): [lindex $li6 1]"
      puts $fID "-Send socket size (bytes): [lindex $li5 0]"
      puts $fID "-Recv socket size (bytes): [lindex $li6 0]"
      puts $fID "-Send throughput (bytes): [lindex $li5 5]"
      puts $fID "-Send OK messages: [lindex $li5 3]"
      puts $fID "-Recv OK messages: [lindex $li6 2]"
      puts $fID "-Failed send calls: [lindex $li5 4]"
   }
   ##Recv Message Size, when provided:
   if $npf6(recvMessageSizeBool) \
   {
       if [string compare {} [string trim $npf6(recvMessageSize)]] \
       {
          puts $fID "-Recv message size (bytes): $npf6(recvMessageSize)"
       }
   }
   set first 1
   for {set i 1} {$i<=$customEnd6} {incr i} \
   {
     if { $first == 1 } {  puts $fID "custom parameters:" }
     puts $fID "-$customparams6(name,$i): $customparams6(value,$i)"
     set first 0 
   }

   #close file
   catch {close $fID}
   ##final message here
   $z insert end " - Data Saved Successfully : $fPath"
   $z insert end " - Netperf Test complete"
   $z see end
   update idletasks
   #tk_messageBox -message 
   $m6tF.consoleF.bF.runB config -text "Run Test" -command RunMTest6
}
